using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

namespace GuiMartialArts
{

    public class MartialArtsData
    {
        MartialArtsDelayCalculation m_delayCalculation;
        MartialArtsDelayCalculation delayCalculation
        {
            get
            {
                if (m_delayCalculation == null)
                {
                    m_delayCalculation = DateFile.instance.gameObject.AddComponent<MartialArtsDelayCalculation>();
                }
                return m_delayCalculation;
            }
        }

        private Dictionary<int, int> gongfaProficiency;
        /// <summary>
        /// 
        /// </summary>
        private Dictionary<int, int> GongfaProficiency
        {
            get
            {
                if (gongfaProficiency == null)
                    gongfaProficiency = new Dictionary<int, int>();
                return gongfaProficiency;
            }
            set
            {
                gongfaProficiency = value;
            }
        }

        private List<int> battleEnemyIds;
        /// <summary>
        /// վĵ
        /// </summary>
        private List<int> BattleEnemyIds
        {
            get
            {
                if (battleEnemyIds == null)
                    battleEnemyIds = new List<int>();
                return battleEnemyIds;
            }
            set
            {
                battleEnemyIds = value;
            }
        }

        private Dictionary<int, int[]> battleGongfaWeitht;
        /// <summary>
        /// սĹȨ
        /// </summary>
        private Dictionary<int, int[]> BattleGongfaWeitht
        {
            get
            {
                if (battleGongfaWeitht == null)
                    battleGongfaWeitht = new Dictionary<int, int[]>();
                return battleGongfaWeitht;
            }
            set
            {
                battleGongfaWeitht = value;
            }
        }

        /// <summary>
        /// սʹõĹ
        /// </summary>
        /// <param name="isActor"></param>
        /// <param name="gongFaId"></param>
        public void AddUseGongfa(bool isActor, int gongFaId)
        {
            if (gongFaId / 10000 > 15)
                return;
            if (isActor)
            {
                if (GongfaProficiency.ContainsKey(gongFaId))
                    GongfaProficiency[gongFaId]++;
                else
                    GongfaProficiency.Add(gongFaId, 1);
                actorUseGongfaTimes++;
            }
            else
            {
                System.Reflection.FieldInfo m_mianEnemyId = typeof(BattleSystem).GetField("mianEnemyId", System.Reflection.BindingFlags.NonPublic | System.Reflection.BindingFlags.Instance);
                int mainEnemyId = (int)m_mianEnemyId.GetValue(BattleSystem.instance); // õid
                var gongFas = DateFile.instance.actorGongFas[mainEnemyId];
                if (!gongFas.ContainsKey(gongFaId))
                    return;
                var gongFaData = gongFas[gongFaId];// [0]ϰ̶  [1]npcķȼ  [2]ҳ
                int playerLevel = 0;
                if (DateFile.instance.gongFaBookPages.ContainsKey(gongFaId))
                {
                    var pages = DateFile.instance.gongFaBookPages[gongFaId];
                    for (int i = 0; i < pages.Length; i++)
                    {
                        if (pages[i] == 1)
                            playerLevel++;
                        else
                            break;
                    }
                }
                // Main.Logger.Log("˹ " + DateFile.instance.gongFaDate[gongFaId][0] + " " + gongFaData[0] + " " + gongFaData[1] + " " + gongFaData[2] + " ҵȼ" + playerLevel);

                if (playerLevel < gongFaData[1])
                {
                    int isNiLian = Random.Range(0, gongFaData[1]) < gongFaData[2] ? 1 : 0; // ж򵽵Ĺ
                    // Main.Logger.Log("¼һʹü¼" + (isNiLian == 1 ? "" : ""));
                    if (!BattleGongfaWeitht.ContainsKey(gongFaId))
                        BattleGongfaWeitht.Add(gongFaId, new int[2]);

                    if (BattleGongfaWeitht[gongFaId][isNiLian] == 1)
                        BattleGongfaWeitht[gongFaId][isNiLian] = 4;
                    else
                        BattleGongfaWeitht[gongFaId][isNiLian] += 2;
                    enemyUseGongfaTimes++;
                }
            }
        }

        /// <summary>
        /// սгսĵ
        /// </summary>
        /// <param name="_newEnemyId"></param>
        /// <param name="_oldEnemyId"></param>
        public void AddBattleEnemy(int _newEnemyId, int _oldEnemyId)
        {
            if (_newEnemyId != 0 && !BattleEnemyIds.Contains(_newEnemyId))
                BattleEnemyIds.Add(_newEnemyId);

            if (_oldEnemyId != 0 && !BattleEnemyIds.Contains(_oldEnemyId))
                BattleEnemyIds.Add(_oldEnemyId);
        }

        int enemyUseGongfaTimes = 0;
        int actorUseGongfaTimes = 0;
        int msgRand = 0;
        string canTitle = "˴սлϰù";
        string zhenChuan = "洫";
        string shouChao = "ֳ";
        string winTitle = "ս";
        string[] failMes = new string[] {
            "սз̫дۡս͵Էʹõġ{0}{1}̫δõʲô<color=#8E8E8EFF>\n侲ءҡ{2}/{3}</color>" ,
        };
        string[] winMsg = new string[] {
            "սз̫дۡս͵Էʹõġ{0}{1}ЩǷĲ<color=#8E8E8EFF>\n侲ءҡ{2}/{3}</color>" ,
            //"㷢одۣսй۲Էת{0}{1}Ƿݹ",
        };
        string[] noMsg = new string[] {
            "սз̫дۡûзκοѧϰĹ\n<color=#8E8E8EFF>ԷûпԱѧϰĹ</color>",
            //"һݣ{0}ϰ{1}ҳ",
        };
        string[] endMsg = new string[] {
            "а{0}ϰ{1}ҳ\n<color=#8E8E8EFF>Եء</color>",
            //"һݣ{0}ϰ{1}ҳ",
        };
        string[] getMsg = new string[] {
            "ս򣬽򵽵Ҫ" + "\nòҳ鼮\n<color=#8E8E8EFF></color>",
            //"һݣ{0}ϰ{1}ҳ",
        };

        int getGongFaId = 0;
        int isNiLian = 0;
        int addGongFaLevel = 0;
        int iconX = -400;
        int iconY = 50;
        GameObject icon;

        public void SaveWindows()
        {
            string msg = GetMessage();

            // Main.Logger.Log("ùȼ:" + addGongFaLevel);

            if (addGongFaLevel > 0)
            {
                Button okbtn = YesOrNoWindow.instance.yesOrNoWindow.Find("YesButton").GetComponent<Button>();
                okbtn.onClick.AddListener(ClickYes);
                Button nobtn = YesOrNoWindow.instance.yesOrNoWindow.Find("NoButton").GetComponent<Button>();
                nobtn.onClick.AddListener(ClickNo);

                Transform parent = YesOrNoWindow.instance.yesOrNoWindow;
                icon = UnityEngine.Object.Instantiate<GameObject>(ActorMenu.instance.gongFa);
                Transform transform = icon.transform;
                icon.name = "GongFa," + getGongFaId;
                SetGongFaIcon component2 = icon.GetComponent<SetGongFaIcon>();
                component2.SetGongFa(getGongFaId, DateFile.instance.MianActorID());
                component2.SetEquipIcon(false);
                transform.SetParent(parent, false);
                transform.localPosition = new Vector3(iconX, iconY, 0);
                icon.SetActive(true);

                // Main.Logger.Log("򹦷:" + msg);
                YesOrNoWindow.instance.SetYesOrNoWindow(1992062500, winTitle, msg, true, true);
            }
            else
            {
                YesOrNoWindow.instance.SetYesOrNoWindow(-1, winTitle, msg, false, true);
            }
        }

        /// <summary>
        /// սĹ  ҷʾַ
        /// </summary>
        /// <returns></returns>
        private string GetMessage()
        {
            // ÿʹôƽ
            int enemyAverage = enemyUseGongfaTimes / (BattleGongfaWeitht.Count + 1);
            // Main.Logger.Log("ÿʹôƽ" + enemyAverage);
            // ˴װڹ
            foreach (int enemyId in BattleEnemyIds)
            {
                // Main.Logger.Log("" + enemyId);
                Dictionary<int, int[]> equipGongfas = new Dictionary<int, int[]>(DateFile.instance.GetActorEquipGongFa(enemyId));
                foreach (var GongFaIds in equipGongfas)
                {
                    var enemyGongFas = DateFile.instance.actorGongFas[enemyId];
                    // 0ڹ 1ǹ 2 3ǻ 4Ǿ

                    int p = (GongFaIds.Key != 1 && GongFaIds.Key != 2 && GongFaIds.Key != 3) ? 4 : 1;
                    Main.Logger.Log("˹");
                    // ˵Ĺ
                    foreach (var gongFaId in GongFaIds.Value)
                    {
                        Main.Logger.Log("˹" + DateFile.instance.gongFaDate[gongFaId][0]);

                        if (gongFaId / 10000 > 15)
                            continue;
                        if (!enemyGongFas.ContainsKey(gongFaId))
                            continue;

                        var gongFaData = enemyGongFas[gongFaId];// [0]ϰ̶  [1]npcķȼ  [2]ҳ
                        int playerLevel = 0;
                        if (gongFaData[0] >= 25)
                        {
                            if (DateFile.instance.gongFaBookPages.ContainsKey(gongFaId))
                            {
                                var pages = DateFile.instance.gongFaBookPages[gongFaId];
                                for (int i = 0; i < pages.Length; i++)
                                {
                                    if (pages[i] == 1)
                                        playerLevel++;
                                    else
                                        break;
                                }
                            }
                            // Main.Logger.Log("˹ " + DateFile.instance.gongFaDate[gongFaId][0] + " " + gongFaData[0] + " " + gongFaData[1] + " " + gongFaData[2] + " ҵȼ" + playerLevel);

                            if (playerLevel < gongFaData[1])
                            {
                                int isNiLian = Random.Range(0, gongFaData[1]) < gongFaData[2] ? 1 : 0; // ж򵽵Ĺ
                                int times = (enemyAverage / p + p);
                                if (!BattleGongfaWeitht.ContainsKey(gongFaId))
                                    BattleGongfaWeitht.Add(gongFaId, new int[2]);
                                BattleGongfaWeitht[gongFaId][isNiLian] += times;
                            }
                        }
                        else
                        {
                            // Main.Logger.Log("˵Ĺ" + DateFile.instance.gongFaDate[gongFaId][0] + ":" + gongFaData[0]);
                        }
                    }
                }
            }

            List<int> GongfaIds = new List<int>();
            string canGetGongFa = canTitle;
            int canGetCount = 0;
            foreach (var item in BattleGongfaWeitht)
            {
                // ˴ӦųѾɵĹ
                if (!GongFaIsMaxLevel(item.Key))
                {
                    for (int i = 0; i < item.Value[0]; i++)
                    {
                        GongfaIds.Add(item.Key);
                    }
                    for (int i = 0; i < item.Value[1]; i++)
                    {
                        GongfaIds.Add(item.Key);
                    }
                    if ((item.Value[0] > 0) || (item.Value[0] > 0))
                    {
                        if (canGetCount < 8)
                        {
                            if (canGetGongFa != canTitle)
                                canGetGongFa += "";
                            canGetGongFa += "" + DateFile.instance.gongFaDate[item.Key][0] + "";
                        }
                        canGetCount++;
                    }
                }
            }
            if (canGetCount > 8)
            {
                canGetGongFa += "" + canGetCount + "Ź";
            }
            msgRand = Random.Range(0, winMsg.Length);
            if (GongfaIds.Count > 0 && canGetGongFa != canTitle)
                canGetGongFa += "";
            else
                canGetGongFa = noMsg[msgRand];


            int rand = 0;
            int gongFaPower = 1;
            // õĹ
            if (GongfaIds.Count > 0)
            {
                getGongFaId = GongfaIds[Random.Range(0, GongfaIds.Count)];
                isNiLian = Random.Range(0, BattleGongfaWeitht[getGongFaId][0] + BattleGongfaWeitht[getGongFaId][1]) < BattleGongfaWeitht[getGongFaId][1] ? 1 : 0; // жѧϰ
                var seven = ActorMenu.instance.GetActorResources(DateFile.instance.MianActorID())[5]; // Ԫ: 0 = ϸ  1 = ӱ  2 = ˮ  3 = ׳  4 =   5 = 侲  6 = Ե
                var stage = int.Parse(DateFile.instance.gongFaDate[getGongFaId][2]);
                gongFaPower = stage * 10;
                rand = (Random.Range(5, 105) + seven + Main.settings.AddWind);
                addGongFaLevel = rand / gongFaPower;
                // Main.Logger.Log("ùȼ" + rand + "/" + gongFaPower + "=" + addGongFaLevel);
                if (addGongFaLevel > 0)
                {
                    canGetGongFa = string.Format(winMsg[msgRand], DateFile.instance.gongFaDate[getGongFaId][0], (isNiLian == 1 ? shouChao : zhenChuan), rand, gongFaPower) + "\n" + canGetGongFa;
                    return canGetGongFa;
                }
                else
                {
                    canGetGongFa = string.Format(failMes[msgRand], DateFile.instance.gongFaDate[getGongFaId][0], (isNiLian == 1 ? shouChao : zhenChuan), rand, gongFaPower) + "\n" + canGetGongFa;
                }
            }
            getGongFaId = 0;
            isNiLian = 0;
            addGongFaLevel = 0;
            return canGetGongFa;
        }

        private void ClickYes()
        {
            int id = OnClick.instance.ID;
            // Main.Logger.Log("ȷϰť:" + id);
            if (id == 1992062500)
            {
                RemoveBind();
                CalculationData();
                ClearData();
            }
        }

        private void ClickNo()
        {
            int id = OnClick.instance.ID;
            // Main.Logger.Log("ȡť:" + id);
            if (id == 1992062500)
            {
                RemoveBind();
                ClearData();
            }
        }

        private void RemoveBind()
        {
            Button okbtn = YesOrNoWindow.instance.yesOrNoWindow.Find("YesButton").GetComponent<Button>();
            okbtn.onClick.RemoveAllListeners();
            Button nobtn = YesOrNoWindow.instance.yesOrNoWindow.Find("NoButton").GetComponent<Button>();
            nobtn.onClick.RemoveAllListeners();
            icon.transform.SetParent(null);
            UnityEngine.Object.Destroy(icon);
        }

        private void ClearData()
        {

            BattleEnemyIds = null;
            BattleGongfaWeitht = null;
            enemyUseGongfaTimes = 0;
            actorUseGongfaTimes = 0;
            // Main.Logger.Log("");
        }

        private void CalculationData()
        {
            var seven = ActorMenu.instance.GetActorResources(DateFile.instance.MianActorID())[6]; // Ԫ: 0 = ϸ  1 = ӱ  2 = ˮ  3 = ׳  4 =   5 = 侲  6 = Ե
            var newSeven = (int)((Random.Range(75, 125) / 100f) * seven);
            addGongFaLevel = (1 * Random.Range(10, 10 + newSeven) / 30 + 1) * Main.settings.ReadLevel;
            int newAddLevel = GongfaUpLevel(getGongFaId, addGongFaLevel, isNiLian);
            if (newAddLevel == -100)
            {
                delayCalculation.msg = getMsg[msgRand];
                return;
            }
            delayCalculation.msg = string.Format(endMsg[msgRand], DateFile.instance.gongFaDate[getGongFaId][0], newAddLevel);
        }

        private bool GongFaIsMaxLevel(int gongFaId)
        {
            //SortedDictionary<int, int[]> sortedDictionary = DateFile.instance.actorGongFas[gongFaId];
            //int gongFaLevel = sortedDictionary[gongFaId][0];
            return DateFile.instance.GetGongFaLevel(DateFile.instance.mianActorId, gongFaId) >= 10;
        }


        private int GongfaUpLevel(int gongFaId, int value, int isNiLian)
        {
            int actorId = DateFile.instance.MianActorID();  // ɫid
            bool flag2 = !DateFile.instance.gongFaBookPages.ContainsKey(gongFaId); // Ƿѧ˼
            if (flag2)
            {
                DateFile.instance.gongFaBookPages.Add(gongFaId, new int[10]);
                AddGongFaBook();
                return -100;
            }
            int[] pages = new int[value];
            int idx = 0;
            for (int i = 0; i < 10; i++)
            {
                if (DateFile.instance.gongFaBookPages[gongFaId][i] == 0 && idx < value)
                {
                    pages[idx++] = i;
                }
            }

            foreach (var pageIndex in pages)
            {
                int num5 = DateFile.instance.gongFaBookPages[gongFaId][pageIndex];
                bool flag3 = num5 != 1 && num5 > -100;
                if (flag3)// 
                {
                    int num6 = int.Parse(DateFile.instance.gongFaDate[gongFaId][2]);

                    bool flag4 = !DateFile.instance.actorGongFas[actorId].ContainsKey(gongFaId);
                    // Main.Logger.Log("flag4 " + flag4);
                    if (flag4)
                    {
                        DateFile.instance.actorGongFas[actorId].Add(gongFaId, new int[3]);
                    }
                    DateFile.instance.gongFaBookPages[gongFaId][pageIndex] = 1;
                    bool flag5 = isNiLian != 0;
                    if (flag5)
                    {
                        DateFile.instance.actorGongFas[actorId][gongFaId][2]++;
                    }
                }
            }
            return idx;
        }
        void AddGongFaBook()
        {
            int itemId = 0;
            foreach (var item in DateFile.instance.presetitemDate)
            {
                if (item.Value.ContainsKey(32))
                {
                    if (int.Parse(item.Value[32]) == getGongFaId) // 32 ǶӦĹ   35Ƿֳ
                    {
                        if (int.Parse(item.Value[35]) == isNiLian)
                        {
                            itemId = item.Key;
                            break;
                        }
                    }
                }
            }

            if (itemId > 0)
            {
                int item = DateFile.instance.GetItem(DateFile.instance.MianActorID(), itemId, 1, true);
                if (item > 0)
                {
                    DateFile.instance.itemsDate[item][33] = "0|0|0|0|0|0|0|0|0|0";
                    DateFile.instance.itemsDate[item][901] = "3";
                    DateFile.instance.itemsDate[item][902] = "3";
                }
            }
        }
    }


    public class MartialArtsDelayCalculation : UnityEngine.MonoBehaviour
    {
        string winTitle = "ս";
        private string m_msg = null;
        public string msg
        {
            set
            {
                // Main.Logger.Log("򹦷 " + value);
                m_msg = value;
            }
        }

        void Update()
        {
            if (m_msg != null)
            {
                // Main.Logger.Log("򹦷 " + YesOrNoWindow.instance.yesOrNoWindow.gameObject.activeSelf);

                if (!YesOrNoWindow.instance.yesOrNoWindow.gameObject.activeSelf)
                {
                    YesOrNoWindow.instance.SetYesOrNoWindow(-1, "ս", m_msg, false, true);
                    m_msg = null;
                }
            }
        }
    }
}

#region  ע
//[GuiMartialArts] YesOrNoWindow True sizeDelta=(720.0, 280.0)
//[GuiMartialArts] -- YesOrNoTitle True sizeDelta=(280.0, 40.0)
//[GuiMartialArts] -- -- YesOrNoTitleText True sizeDelta=(0.0, 0.0)
//[GuiMartialArts] -- -- YesOrNoMassageText True sizeDelta=(580.0, 140.0)
//[GuiMartialArts] -- NoButton True sizeDelta=(60.0, 60.0)
//[GuiMartialArts] -- -- Image True sizeDelta=(0.0, 0.0)
//[GuiMartialArts] -- YesButton True sizeDelta=(90.0, 90.0)
//[GuiMartialArts] -- -- Image True sizeDelta=(0.0, 0.0)


#region 
//[GuiMartialArts] num 10001
//[GuiMartialArts] idnum3 10701
//[GuiMartialArts] num4 60
//[GuiMartialArts]
//flag True
//[GuiMartialArts] ǹ
//[GuiMartialArts] flag2 True
//[GuiMartialArts] num5 0
//[GuiMartialArts]
//flag3 True
//[GuiMartialArts] num6 1
//[GuiMartialArts] num7 1
//[GuiMartialArts]
//flag4 False
//[GuiMartialArts] flag5 True
//[GuiMartialArts] flag6 False
//[GuiMartialArts] flag7 False
//[GuiMartialArts] num 10001
//[GuiMartialArts] idnum3 10701
//[GuiMartialArts] num4 60
//[GuiMartialArts]
//flag True
//[GuiMartialArts] ǹ
//[GuiMartialArts] flag2 False
//[GuiMartialArts] num5 0
//[GuiMartialArts]
//flag3 True
//[GuiMartialArts] num6 1
//[GuiMartialArts] num7 1
//[GuiMartialArts]
//flag4 False
//[GuiMartialArts] flag5 True
//[GuiMartialArts] flag6 False
//[GuiMartialArts] flag7 False
//[GuiMartialArts] num 10001
//[GuiMartialArts] idnum3 10701
//[GuiMartialArts] num4 60
//[GuiMartialArts]
//flag True
//[GuiMartialArts] ǹ
//[GuiMartialArts] flag2 False
//[GuiMartialArts] num5 0
//[GuiMartialArts]
//flag3 True
//[GuiMartialArts] num6 1
//[GuiMartialArts] num7 1
//[GuiMartialArts]
//flag4 False
//[GuiMartialArts] flag5 True
//[GuiMartialArts] flag6 False
//[GuiMartialArts] flag7 False
//[GuiMartialArts] num 10001
//[GuiMartialArts] idnum3 10701
//[GuiMartialArts] num4 60
//[GuiMartialArts]
//flag True
//[GuiMartialArts] ǹ
//[GuiMartialArts] flag2 False
//[GuiMartialArts] num5 0
//[GuiMartialArts]
//flag3 True
//[GuiMartialArts] num6 1
//[GuiMartialArts] num7 1
//[GuiMartialArts]
//flag4 False
//[GuiMartialArts] flag5 True
//[GuiMartialArts] flag6 False
//[GuiMartialArts] flag7 True
#endregion

#region 
//[GuiMartialArts] num 10001
//[GuiMartialArts] idnum3 150001
//[GuiMartialArts] num4 60
//[GuiMartialArts]
//flag True
//[GuiMartialArts] ǹ
//[GuiMartialArts] flag2 True
//[GuiMartialArts] num5 0
//[GuiMartialArts]
//flag3 True
//[GuiMartialArts] num6 1
//[GuiMartialArts] num7 0
//[GuiMartialArts]
//flag4 False
//[GuiMartialArts] flag5 False
//[GuiMartialArts] flag6 False
//[GuiMartialArts] flag7 False
//[GuiMartialArts] num 10001
//[GuiMartialArts] idnum3 150001
//[GuiMartialArts] num4 60
//[GuiMartialArts]
//flag True
//[GuiMartialArts] ǹ
//[GuiMartialArts] flag2 False
//[GuiMartialArts] num5 0
//[GuiMartialArts]
//flag3 True
//[GuiMartialArts] num6 1
//[GuiMartialArts] num7 0
//[GuiMartialArts]
//flag4 False
//[GuiMartialArts] flag5 False
//[GuiMartialArts] flag6 False
//[GuiMartialArts] flag7 False
//[GuiMartialArts] num 10001
//[GuiMartialArts] idnum3 150001
//[GuiMartialArts] num4 60
//[GuiMartialArts]
//flag True
//[GuiMartialArts] ǹ
//[GuiMartialArts] flag2 False
//[GuiMartialArts] num5 0
//[GuiMartialArts]
//flag3 True
//[GuiMartialArts] num6 1
//[GuiMartialArts] num7 0
//[GuiMartialArts]
//flag4 False
//[GuiMartialArts] flag5 False
//[GuiMartialArts] flag6 False
//[GuiMartialArts] flag7 False
//[GuiMartialArts] num 10001
//[GuiMartialArts] idnum3 150001
//[GuiMartialArts] num4 60
//[GuiMartialArts]
//flag True
//[GuiMartialArts] ǹ
//[GuiMartialArts] flag2 False
//[GuiMartialArts] num5 0
//[GuiMartialArts]
//flag3 True
//[GuiMartialArts] num6 1
//[GuiMartialArts] num7 0
//[GuiMartialArts]
//flag4 False
//[GuiMartialArts] flag5 False
//[GuiMartialArts] flag6 False
//[GuiMartialArts] flag7 False
//[GuiMartialArts] num 10001
//[GuiMartialArts] idnum3 150001
//[GuiMartialArts] num4 60
//[GuiMartialArts]
//flag True
//[GuiMartialArts] ǹ
//[GuiMartialArts] flag2 False
//[GuiMartialArts] num5 0
//[GuiMartialArts]
//flag3 True
//[GuiMartialArts] num6 1
//[GuiMartialArts] num7 0
//[GuiMartialArts]
//flag4 False
//[GuiMartialArts] flag5 False
//[GuiMartialArts] flag6 False
//[GuiMartialArts] flag7 False
//[GuiMartialArts] num 10001
//[GuiMartialArts] idnum3 150001
//[GuiMartialArts] num4 60
//[GuiMartialArts]
//flag True
//[GuiMartialArts] ǹ
//[GuiMartialArts] flag2 False
//[GuiMartialArts] num5 0
//[GuiMartialArts]
//flag3 True
//[GuiMartialArts] num6 1
//[GuiMartialArts] num7 0
//[GuiMartialArts]
//flag4 False
//[GuiMartialArts] flag5 False
//[GuiMartialArts] flag6 False
//[GuiMartialArts] flag7 False
//[GuiMartialArts] num 10001
//[GuiMartialArts] idnum3 150001
//[GuiMartialArts] num4 60
//[GuiMartialArts]
//flag True
//[GuiMartialArts] ǹ
//[GuiMartialArts] flag2 False
//[GuiMartialArts] num5 0
//[GuiMartialArts]
//flag3 True
//[GuiMartialArts] num6 1
//[GuiMartialArts] num7 0
//[GuiMartialArts]
//flag4 False
//[GuiMartialArts] flag5 False
//[GuiMartialArts] flag6 False
//[GuiMartialArts] flag7 False
//[GuiMartialArts] num 10001
//[GuiMartialArts] idnum3 150001
//[GuiMartialArts] num4 60
//[GuiMartialArts]
//flag True
//[GuiMartialArts] ǹ
//[GuiMartialArts] flag2 False
//[GuiMartialArts] num5 0
//[GuiMartialArts]
//flag3 True
//[GuiMartialArts] num6 1
//[GuiMartialArts] num7 0
//[GuiMartialArts]
//flag4 False
//[GuiMartialArts] flag5 False
//[GuiMartialArts] flag6 False
//[GuiMartialArts] flag7 False
//[GuiMartialArts] num 10001
//[GuiMartialArts] idnum3 150001
//[GuiMartialArts] num4 60
//[GuiMartialArts]
//flag True
//[GuiMartialArts] ǹ
//[GuiMartialArts] flag2 False
//[GuiMartialArts] num5 0
//[GuiMartialArts]
//flag3 True
//[GuiMartialArts] num6 1
//[GuiMartialArts] num7 0
//[GuiMartialArts]
//flag4 False
//[GuiMartialArts] flag5 False
//[GuiMartialArts] flag6 False
//[GuiMartialArts] flag7 False
//[GuiMartialArts] num 10001
//[GuiMartialArts] idnum3 150001
//[GuiMartialArts] num4 60
//[GuiMartialArts]
//flag True
//[GuiMartialArts] ǹ
//[GuiMartialArts] flag2 False
//[GuiMartialArts] num5 0
//[GuiMartialArts]
//flag3 True
//[GuiMartialArts] num6 1
//[GuiMartialArts] num7 0
//[GuiMartialArts]
//flag4 False
//[GuiMartialArts] flag5 False
//[GuiMartialArts] flag6 False
//[GuiMartialArts] flag7 True
//[GuiMartialArts] num 10001
//[GuiMartialArts] idnum3 150001
//[GuiMartialArts] num4 60
//[GuiMartialArts]
//flag True
//[GuiMartialArts] ǹ
//[GuiMartialArts] flag2 False
//[GuiMartialArts] num5 1
//[GuiMartialArts]
//flag3 False
#endregion









//[GuiMartialArts] ҹ0 100 0 0
//[GuiMartialArts]
//0 ɷ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 0
//[GuiMartialArts] 62 0
//[GuiMartialArts] 63 0
//[GuiMartialArts] 64 0
//[GuiMartialArts] 66 0
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 0
//[GuiMartialArts] 69 0
//[GuiMartialArts]
//70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 0
//[GuiMartialArts] 99 ³šν֮һڹĸڡ
//[GuiMartialArts] 103 0
//[GuiMartialArts] 104 0
//[GuiMartialArts] 1 -1
//[GuiMartialArts] 6 -1
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 0
//[GuiMartialArts] 15 0
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 0
//[GuiMartialArts] 701 0.025
//[GuiMartialArts] 702 0.025
//[GuiMartialArts] 703 0.025
//[GuiMartialArts] 704 0.025
//[GuiMartialArts] 705 0.025
//[GuiMartialArts] 999 100
//[GuiMartialArts] 710 601&0.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 1
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 1
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 1
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 1
//[GuiMartialArts] 922 1
//[GuiMartialArts] 923 1
//[GuiMartialArts] 924 1
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ101 100 0 0
//[GuiMartialArts]
//0 
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 9
//[GuiMartialArts]
//70 ­ϢѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ް徻ۣϰ徲˼ԴﵽһļԵĿ򾳽硣
//[GuiMartialArts] 103 1
//[GuiMartialArts] 104 5001
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0.02
//[GuiMartialArts] 702 0.02
//[GuiMartialArts] 703 0.02
//[GuiMartialArts] 704 0.02
//[GuiMartialArts] 705 0.02
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.5|65&0.25|66&0.75|514&0.6
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 1
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 1
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 2
//[GuiMartialArts] 922 2
//[GuiMartialArts] 923 4
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ102 100 0 0
//[GuiMartialArts]
//0 ޺
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 9
//[GuiMartialArts]
//70 ޹
//[GuiMartialArts] 71 ͷ
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ޺ھ޹ǣɨаͷǣԿۣҹ׳ھķš
//[GuiMartialArts] 103 2
//[GuiMartialArts] 104 5002
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0.2
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.75|62&0.35|66&0.8|514&0.9
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 1
//[GuiMartialArts] 923 8
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0.5
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.1
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.2
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 15
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ103 100 0 0
//[GuiMartialArts]
//0 Ԫ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 9
//[GuiMartialArts]
//70 Ѩ
//[GuiMartialArts] 71 йѨ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ϣϣϡ֮ԪԪƽȻ֮Ϣ۳֮˹ʱţȴ
//[GuiMartialArts] 103 3
//[GuiMartialArts] 104 5003
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0.3
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.15|64&0.3|65&0.3|66&0.7|514&1.35
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 1
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 1
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 3
//[GuiMartialArts] 922 1
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0.5
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.2
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 15
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ104 100 0 0
//[GuiMartialArts]
//0 ɫ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts]
//70 Ѩ
//[GuiMartialArts] 71 ӭѨ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ɫģ޼ƹžʵȴԴԴϡǣޱߡʶޱߡСǷ롱֮ж֮
//[GuiMartialArts] 103 4
//[GuiMartialArts] 104 5004
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0.08
//[GuiMartialArts] 702 0.08
//[GuiMartialArts] 703 0.08
//[GuiMartialArts] 704 0.08
//[GuiMartialArts] 705 0.08
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.5|65&0.45|66&1|514&1.8
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 1
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 2
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 3
//[GuiMartialArts] 921 2
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0.75
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.1
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.75
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0.1
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 1
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ105 100 0 0
//[GuiMartialArts]
//0 ޷
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 7
//[GuiMartialArts]
//70 ϲ
//[GuiMartialArts] 71 ȱ
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 һд˷֮֮Ҫ֣ܻɱ˷֮ѧĸ߾硣
//[GuiMartialArts] 103 5
//[GuiMartialArts] 104 5005
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0.5
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.9|65&0.5|66&1.1|514&2.3
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 1
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 3
//[GuiMartialArts] 921 2
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 1
//[GuiMartialArts] 51110 1
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.75
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.75
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 15
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ106 100 0 0
//[GuiMartialArts]
//0 Ӱ
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts]
//70 Ѩ
//[GuiMartialArts] 71 زѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 Ӱǧ㷨ţֹ޾Գħδɽ֮򣬿֤һ˼룬δ֮
//[GuiMartialArts] 103 6
//[GuiMartialArts] 104 5006
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0.6
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.3|64&0.35|65&0.55|66&0.85|514&2.75
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 1
//[GuiMartialArts] 904 1
//[GuiMartialArts] 905 1
//[GuiMartialArts] 906 1
//[GuiMartialArts] 907 1
//[GuiMartialArts] 908 1
//[GuiMartialArts] 909 1
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 2
//[GuiMartialArts] 922 2
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 1
//[GuiMartialArts] 50033 1
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.5
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1
//[GuiMartialArts] 50072 1
//[GuiMartialArts] 50073 1
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 15
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ107 100 0 0
//[GuiMartialArts]
//0 ޺
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts]
//70 º
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ǧ۷̥۾񣬹ʹа˱ܣʦͨԳɣ˼ǰ޺񹦡
//[GuiMartialArts] 103 7
//[GuiMartialArts] 104 5007
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0.7
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.65|62&1.3|66&0.6|514&3.2
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 9
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.75
//[GuiMartialArts] 50023 1.5
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.4
//[GuiMartialArts] 50082 0.4
//[GuiMartialArts] 50083 1
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.75
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 15
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ108 100 0 0
//[GuiMartialArts]
//0 ׽
//[GuiMartialArts] 2 8
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 90
//[GuiMartialArts] 64 0.8
//[GuiMartialArts] 66 66
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts]
//70 
//[GuiMartialArts] 71 ӡ
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 545
//[GuiMartialArts] 99 ĦʦǿǣǱ֮׳񹦡ǣ׽ѱϣɽ塣в֣ʳΪ
//[GuiMartialArts] 103 8
//[GuiMartialArts] 104 5008
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 8
//[GuiMartialArts] 701 0.16
//[GuiMartialArts] 702 0.16
//[GuiMartialArts] 703 0.16
//[GuiMartialArts] 704 0.16
//[GuiMartialArts] 705 0.16
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&3.05|62&1.1|66&0.95|514&3.65
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 2
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 2
//[GuiMartialArts] 923 7
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 5
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.2
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.5
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 1.5
//[GuiMartialArts] 51367 0.3
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ109 100 0 0
//[GuiMartialArts]
//0 ϴ辭
//[GuiMartialArts] 2 9
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 5
//[GuiMartialArts] 63 100
//[GuiMartialArts] 64 0.9
//[GuiMartialArts] 66 83
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 9
//[GuiMartialArts]
//70 Ѩ
//[GuiMartialArts] 71 ͥѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 680
//[GuiMartialArts] 99 ƣ䤹ǸǢ裬ѿǷȥ뻯죬ĩ󾿾ءϴ辭ǴĦʦ֮ڵԪ̥ǵ׳񹦡
//[GuiMartialArts] 103 9
//[GuiMartialArts] 104 5009
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 9
//[GuiMartialArts] 701 0.18
//[GuiMartialArts] 702 0.18
//[GuiMartialArts] 703 0.18
//[GuiMartialArts] 704 0.18
//[GuiMartialArts] 705 0.18
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&3.45|64&1.1|66&1.1|514&4.15
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 2
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 2
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 2
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 3
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 4
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 5
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0.75
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.2
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.5
//[GuiMartialArts] 50083 1.75
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0.3
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ201 100 0 4
//[GuiMartialArts]
//0 ￪Ϲ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 9
//[GuiMartialArts]
//70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 µ˳ɻԪ￪֮֮ԪСתΪԪؾ
//[GuiMartialArts] 103 10
//[GuiMartialArts] 104 5010
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.1
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.5|64&0.5|66&0.5|513&0.55|514&0.55
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 1
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 3
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 2
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0.1
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ202 100 0 0
//[GuiMartialArts]
//0 üʮ׮
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 9
//[GuiMartialArts]
//70 ȪѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ʮ׮һãѧҽ֮һ塣ܹ࣬ǿϢܰԡ
//[GuiMartialArts] 103 11
//[GuiMartialArts] 104 5011
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.2
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.75|65&0.55|66&0.6|513&0.8|514&0.8
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 5
//[GuiMartialArts] 923 1
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0.1
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ203 100 0 0
//[GuiMartialArts]
//0 һԪ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts]
//70 ͨѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 һԪǣ̱Ԫ֮ߣؼһΪԪ
//[GuiMartialArts] 103 12
//[GuiMartialArts] 104 5012
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.3
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.15|64&0.8|66&0.5|513&1.25|514&1.25
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 7
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.1
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.5
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0.1
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ204 100 0 0
//[GuiMartialArts]
//0 
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts]
//70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˳ӦȻá򡱣Ϊ򹦡򹦷Ԫޣʱ飬ʱڿ֮š
//[GuiMartialArts] 103 13
//[GuiMartialArts] 104 5013
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.4
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.5|65&0.8|66&0.65|513&1.65|514&1.65
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 2
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 2
//[GuiMartialArts] 922 5
//[GuiMartialArts] 923 2
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0.2
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0.2
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ205 100 0 0
//[GuiMartialArts] 0 ̫
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ֤Уۻ಻Ⱦ粨̫ۡǻ壬Ȼϼٺ֡
//[GuiMartialArts] 103 14
//[GuiMartialArts] 104 5014
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.5
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.9|64&0.55|65&0.55|66&0.5|513&2.1|514&2.1
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 3
//[GuiMartialArts] 922 5
//[GuiMartialArts] 923 4
//[GuiMartialArts] 924 7
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0.5
//[GuiMartialArts] 50042 0.5
//[GuiMartialArts] 50043 0.5
//[GuiMartialArts] 50044 0.5
//[GuiMartialArts] 50045 0.5
//[GuiMartialArts] 50046 0.5
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 1.5
//[GuiMartialArts] 51110 0.75
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.75
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ206 100 0 0
//[GuiMartialArts] 0 ľ
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ľ޲ܣ˳Сʮʮ̡ͨ㷨ţǣŻͨǧ
//[GuiMartialArts] 103 15
//[GuiMartialArts] 104 5015
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.6
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.3|64&0.45|65&0.45|66&0.85|513&2.5|514&2.5
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 1
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 1
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 3
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 1.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0.2
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1
//[GuiMartialArts] 50072 1
//[GuiMartialArts] 50073 1
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ207 100 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ԿѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ޶ʽ޶ʽ޶Σ޶⣬ǣ֫壬ȥ֪ͬڴͨν
//[GuiMartialArts] 103 16
//[GuiMartialArts] 104 5016
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0.14
//[GuiMartialArts] 702 0.14
//[GuiMartialArts] 703 0.14
//[GuiMartialArts] 704 0.14
//[GuiMartialArts] 705 0.14
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.65|65&1.2|66&0.7|513&2.95|514&2.95
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 1
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 7
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0.3
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 1
//[GuiMartialArts] 50085 1
//[GuiMartialArts] 50086 1
//[GuiMartialArts] 51370 0.2
//[GuiMartialArts] 51371 0.2
//[GuiMartialArts] 51372 0.2
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0.3
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ208 100 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 8
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 90
//[GuiMartialArts] 64 0.8
//[GuiMartialArts] 66 66
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ٻѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 545
//[GuiMartialArts] 99 ิֻأŶܣ˥ʢǿ֮ͨҲ
//[GuiMartialArts] 103 17
//[GuiMartialArts] 104 5017
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 8
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.8
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&3.05|64&0.65|65&0.6|66&0.8|513&3.35|514&3.35
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 6
//[GuiMartialArts] 921 2
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 8
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 2.5
//[GuiMartialArts] 50033 2.5
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 1.5
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1.25
//[GuiMartialArts] 50072 1.25
//[GuiMartialArts] 50073 1.25
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ301 100 0 0
//[GuiMartialArts] 0 ͭѨͼ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ϪѨ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 18
//[GuiMartialArts] 104 5018
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0.1
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.45|65&0.75|66&0.25|509&0.65
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 2
//[GuiMartialArts] 922 6
//[GuiMartialArts] 923 4
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0.25
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.25
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.25
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 45
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ302 100 0 0
//[GuiMartialArts] 0 ʮԭ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 ӿȪѨ
//[GuiMartialArts] 71 ḮѨ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 19
//[GuiMartialArts] 104 5019
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0.2
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.65|65&0.8|66&0.35|509&1
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 6
//[GuiMartialArts] 923 2
//[GuiMartialArts] 924 7
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 1.25
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.25
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 45
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ303 100 0 0
//[GuiMartialArts] 0 ȫƪ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 20
//[GuiMartialArts] 104 5020
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0.06
//[GuiMartialArts] 702 0.06
//[GuiMartialArts] 703 0.06
//[GuiMartialArts] 704 0.06
//[GuiMartialArts] 705 0.06
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1|65&0.65|66&0.65|509&1.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 3
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 7
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0.5
//[GuiMartialArts] 51110 1.25
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.5
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ304 100 0 0
//[GuiMartialArts] 0 ھƪ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 21
//[GuiMartialArts] 104 5021
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0.08
//[GuiMartialArts] 702 0.08
//[GuiMartialArts] 703 0.08
//[GuiMartialArts] 704 0.08
//[GuiMartialArts] 705 0.08
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.35|65&1|66&0.45|509&2
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 1
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 2
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 4
//[GuiMartialArts] 924 8
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 1
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 1.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0.2
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0.1
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ305 100 0 0
//[GuiMartialArts] 0 뷥
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 нѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 22
//[GuiMartialArts] 104 5022
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0.5
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.7|65&1.1|66&0.5|509&2.5
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 6
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 7
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 1
//[GuiMartialArts] 50042 1
//[GuiMartialArts] 50043 1
//[GuiMartialArts] 50044 1
//[GuiMartialArts] 50045 1
//[GuiMartialArts] 50046 1
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 1.75
//[GuiMartialArts] 51110 1
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 45
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ401 100 0 0
//[GuiMartialArts] 0 䵱̫͹
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 άѨ
//[GuiMartialArts] 71 羮Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 23
//[GuiMartialArts] 104 5023
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0.02
//[GuiMartialArts] 702 0.02
//[GuiMartialArts] 703 0.02
//[GuiMartialArts] 704 0.02
//[GuiMartialArts] 705 0.02
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.55|64&0.65|66&0.35|513&0.55
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 1
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 1
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 2
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.1
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ402 100 0 0
//[GuiMartialArts] 0 Ԫһ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 ־Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 24
//[GuiMartialArts] 104 5024
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0.2
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.8|64&0.7|66&0.45|513&0.8
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 2
//[GuiMartialArts] 922 2
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.2
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0.1
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 60
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ403 100 0 0
//[GuiMartialArts] 0 һֻԪ׮
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 25
//[GuiMartialArts] 104 5025
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0.06
//[GuiMartialArts] 702 0.06
//[GuiMartialArts] 703 0.06
//[GuiMartialArts] 704 0.06
//[GuiMartialArts] 705 0.06
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.25|64&0.65|66&0.65|513&1.25
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 1
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 1
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 2
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 4
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.2
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0.1
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0.1
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ404 100 0 0
//[GuiMartialArts] 0 ʮ׮
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 26
//[GuiMartialArts] 104 5026
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0.4
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.65|62&0.3|64&0.6|66&0.55|513&1.65
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 1
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 5
//[GuiMartialArts] 923 4
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 1.25
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.3
//[GuiMartialArts] 50083 0.75
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 1
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 60
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ405 100 0 0
//[GuiMartialArts] 0 ϴ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ׵Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 27
//[GuiMartialArts] 104 5027
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0.5
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.1|62&0.45|64&0.9|66&0.25|513&2.1
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 1
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0.75
//[GuiMartialArts] 51110 0.75
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0.2
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 1
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0.2
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0.2
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 60
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ406 100 0 0
//[GuiMartialArts] 0 䵱Ԫ
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 28
//[GuiMartialArts] 104 5028
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0.12
//[GuiMartialArts] 702 0.12
//[GuiMartialArts] 703 0.12
//[GuiMartialArts] 704 0.12
//[GuiMartialArts] 705 0.12
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.5|64&1|66&0.75|513&2.5
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 1
//[GuiMartialArts] 906 1
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 1
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 3
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 1.75
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.4
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0.2
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 1.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0.1
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ407 100 0 0
//[GuiMartialArts] 0 ̫
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 ͻѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 29
//[GuiMartialArts] 104 5029
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0.14
//[GuiMartialArts] 702 0.14
//[GuiMartialArts] 703 0.14
//[GuiMartialArts] 704 0.14
//[GuiMartialArts] 705 0.14
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.95|64&1.1|66&0.8|513&2.95
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 1
//[GuiMartialArts] 906 1
//[GuiMartialArts] 907 1
//[GuiMartialArts] 908 1
//[GuiMartialArts] 909 1
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 2
//[GuiMartialArts] 922 6
//[GuiMartialArts] 923 2
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.3
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 -0.1
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.5
//[GuiMartialArts] 50083 0.75
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0.3
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 1.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0.1
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0.3
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ408 100 0 5
//[GuiMartialArts] 0 ޼
//[GuiMartialArts] 2 8
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 90
//[GuiMartialArts] 64 0.8
//[GuiMartialArts] 66 66
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 545
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 30
//[GuiMartialArts] 104 5030
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 8
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0.8
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&3.35|62&0.35|64&1.15|66&0.55|513&3.35
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 1
//[GuiMartialArts] 908 1
//[GuiMartialArts] 909 1
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 2.5
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0.3
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 1.5
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 1.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0.1
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 2
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0.3
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0.3
//[GuiMartialArts] 98 60
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ501 100 0 4
//[GuiMartialArts] 0 巨
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 ˮͻѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 31
//[GuiMartialArts] 104 5031
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 5
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0.1
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.55|62&0.55|66&0.45|513&0.5|514&0.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0.1
//[GuiMartialArts] 50098 0.1
//[GuiMartialArts] 98 75
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ502 100 0 2
//[GuiMartialArts] 0 СԪɽ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ȼ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 32
//[GuiMartialArts] 104 5032
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 5
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0.2
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.8|62&0.65|66&0.5|513&0.75|514&0.75
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0.1
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.25
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0.2
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 75
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ503 100 0 0
//[GuiMartialArts] 0 Ԫɽ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 ౾
//[GuiMartialArts] 71 ƹ
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 33
//[GuiMartialArts] 104 5033
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 5
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0.3
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.25|62&0.7|66&0.6|513&1.15|514&1.15
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 7
//[GuiMartialArts] 922 2
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0.2
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.5
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.25
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0.2
//[GuiMartialArts] 98 75
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ504 100 0 0
//[GuiMartialArts] 0 ľ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 ͻѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 34
//[GuiMartialArts] 104 5034
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 5
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0.4
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.65|62&0.75|66&0.7|513&1.5|514&1.5
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 1
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 5
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.1
//[GuiMartialArts] 51102 0.1
//[GuiMartialArts] 51103 -0.1
//[GuiMartialArts] 51104 -0.1
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 75
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ505 100 0 0
//[GuiMartialArts] 0 Ԫ๦
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 35
//[GuiMartialArts] 104 5035
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 5
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0.5
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.1|62&0.8|66&0.8|513&1.9|514&1.9
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 1
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 1
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 2
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0.3
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.75
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1
//[GuiMartialArts] 50072 1
//[GuiMartialArts] 50073 1
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0.2
//[GuiMartialArts] 50098 0.2
//[GuiMartialArts] 98 75
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ601 100 0 0
//[GuiMartialArts] 0 ڹ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 36
//[GuiMartialArts] 104 5036
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 6
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0.02
//[GuiMartialArts] 702 0.02
//[GuiMartialArts] 703 0.02
//[GuiMartialArts] 704 0.02
//[GuiMartialArts] 705 0.02
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.65|62&1
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 2
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 20
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 1
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 -0.1
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0.1
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ602 100 0 0
//[GuiMartialArts] 0 ʮ̫
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 37
//[GuiMartialArts] 104 5037
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 6
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0.2
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1|62&1.15
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 1
//[GuiMartialArts] 923 9
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 2
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 -0.2
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 15
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ603 100 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 ƹ
//[GuiMartialArts] 71 Ϻ
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 38
//[GuiMartialArts] 104 5038
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 6
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0.3
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.5|62&1.3
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 20
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0.75
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 -0.3
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.5
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 15
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ604 100 0 0
//[GuiMartialArts] 0 ʨӾ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 39
//[GuiMartialArts] 104 5039
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 6
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0.4
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2|62&1.45
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 8
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 30
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0.5
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.5
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1.75
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0.2
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 15
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ701 100 0 0
//[GuiMartialArts] 0 ־
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 רע
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 40
//[GuiMartialArts] 104 5040
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0.02
//[GuiMartialArts] 702 0.02
//[GuiMartialArts] 703 0.02
//[GuiMartialArts] 704 0.02
//[GuiMartialArts] 705 0.02
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.45|65&0.75|66&0.25|505&0.6|516&0.6
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 5
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0.1
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ702 100 0 0
//[GuiMartialArts] 0 תԲ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 ˼
//[GuiMartialArts] 71 Բת
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 41
//[GuiMartialArts] 104 5041
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.2
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.65|63&0.25|65&0.9|505&0.9|516&0.9
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 1
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 3
//[GuiMartialArts] 922 6
//[GuiMartialArts] 923 4
//[GuiMartialArts] 924 3
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.1
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ703 100 0 0
//[GuiMartialArts] 0 ʵⷨ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 ڤ˼
//[GuiMartialArts] 71 ޻
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 42
//[GuiMartialArts] 104 5042
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.3
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1|64&0.25|65&1.05|505&1.35|516&1.35
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 7
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0.2
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ704 100 0 0
//[GuiMartialArts] 0 ÷
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 ᶨ
//[GuiMartialArts] 71 龲
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 43
//[GuiMartialArts] 104 5043
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.4
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.35|65&1.1|66&0.35|505&1.8|516&1.8
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 1
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 1
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 5
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 3
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.2
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 1
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0.2
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ705 100 0 0
//[GuiMartialArts] 0 ʢ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 ϲ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 44
//[GuiMartialArts] 104 5044
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.5
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.7|62&0.3|65&1.3|505&2.3|516&2.3
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 7
//[GuiMartialArts] 922 6
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0.75
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.2
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 -0.1
//[GuiMartialArts] 51104 -0.1
//[GuiMartialArts] 51105 0.4
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.5
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ706 100 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 ŷ
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 45
//[GuiMartialArts] 104 5045
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.6
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.05|64&0.35|65&1.4|505&2.75|516&2.75
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 5
//[GuiMartialArts] 923 7
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 1.25
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.75
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0.2
//[GuiMartialArts] 51371 0.2
//[GuiMartialArts] 51372 0.2
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ707 100 0 0
//[GuiMartialArts] 0 ɢƷ
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 ۱
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 46
//[GuiMartialArts] 104 5046
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0.14
//[GuiMartialArts] 702 0.14
//[GuiMartialArts] 703 0.14
//[GuiMartialArts] 704 0.14
//[GuiMartialArts] 705 0.14
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.4|65&1.5|66&0.4|505&3.2|516&3.2
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 7
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.3
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.3
//[GuiMartialArts] 50083 0.5
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0.2
//[GuiMartialArts] 51369 0.25
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1.5
//[GuiMartialArts] 50072 1.5
//[GuiMartialArts] 50073 1.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ708 100 0 0
//[GuiMartialArts] 0 ΢
//[GuiMartialArts] 2 8
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 90
//[GuiMartialArts] 64 0.8
//[GuiMartialArts] 66 66
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 545
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 47
//[GuiMartialArts] 104 5047
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 8
//[GuiMartialArts] 701 0.16
//[GuiMartialArts] 702 0.16
//[GuiMartialArts] 703 0.16
//[GuiMartialArts] 704 0.16
//[GuiMartialArts] 705 0.16
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.75|64&0.45|65&1.6|505&3.65|516&3.65
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 1
//[GuiMartialArts] 909 2
//[GuiMartialArts] 910 3
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 4
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 1.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 1.5
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 1.5
//[GuiMartialArts] 50085 1.5
//[GuiMartialArts] 50086 1.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0.3
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ801 100 0 0
//[GuiMartialArts] 0 Ůľ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ȪѨ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 48
//[GuiMartialArts] 104 5048
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0.1
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.65|64&0.65|65&0.35
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 3
//[GuiMartialArts] 922 7
//[GuiMartialArts] 923 1
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.1
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0.1
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 45
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ802 100 0 3
//[GuiMartialArts] 0 ǹ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 мѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 49
//[GuiMartialArts] 104 5049
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0.2
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1|64&0.7|65&0.45
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 1
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 3
//[GuiMartialArts] 922 6
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0.1
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.2
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0.1
//[GuiMartialArts] 98 45
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ803 100 0 0
//[GuiMartialArts] 0 ¹
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 50
//[GuiMartialArts] 104 5050
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0.3
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.5|63&0.75|65&0.55
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 9
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0.2
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.2
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 45
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ804 100 0 0
//[GuiMartialArts] 0 һ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 51
//[GuiMartialArts] 104 5051
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0.08
//[GuiMartialArts] 702 0.08
//[GuiMartialArts] 703 0.08
//[GuiMartialArts] 704 0.08
//[GuiMartialArts] 705 0.08
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2|62&1.45
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 8
//[GuiMartialArts] 922 6
//[GuiMartialArts] 923 4
//[GuiMartialArts] 924 3
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0.2
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0.2
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ805 100 0 0
//[GuiMartialArts] 0 澭
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ̫ԨѨ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 52
//[GuiMartialArts] 104 5052
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0.5
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.5|64&0.95|65&0.65
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 2
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.2
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.75
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0.15
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 1
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0.2
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 45
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ806 100 0 0
//[GuiMartialArts] 0 Ů
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 պѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 53
//[GuiMartialArts] 104 5053
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0.6
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&3|64&1|65&0.75
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 6
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 7
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.75
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.3
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.3
//[GuiMartialArts] 50083 0.5
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0.2
//[GuiMartialArts] 98 45
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ807 100 0 0
//[GuiMartialArts] 0 ԡ
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 ѪѨ
//[GuiMartialArts] 71 ̫Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 54
//[GuiMartialArts] 104 5054
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0.7
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&3.5|63&1|64&0.9
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 8
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 8
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 1
//[GuiMartialArts] 50042 1
//[GuiMartialArts] 50043 1
//[GuiMartialArts] 50044 1
//[GuiMartialArts] 50045 1
//[GuiMartialArts] 50046 1
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 1
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0.3
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 1.5
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0.75
//[GuiMartialArts] 50086 0.75
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0.3
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 45
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ808 100 0 0
//[GuiMartialArts] 0 ̫ԪŮ
//[GuiMartialArts] 2 8
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 90
//[GuiMartialArts] 64 0.8
//[GuiMartialArts] 66 66
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 545
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 55
//[GuiMartialArts] 104 5055
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 8
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0.8
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&4|64&1.25|65&0.8
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 1
//[GuiMartialArts] 909 1
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 5
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 1
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.3
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.4
//[GuiMartialArts] 50083 1
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0.2
//[GuiMartialArts] 51369 0.2
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.75
//[GuiMartialArts] 50072 0.75
//[GuiMartialArts] 50073 0.75
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0.3
//[GuiMartialArts] 98 45
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ809 100 0 0
//[GuiMartialArts] 0 ̫һ
//[GuiMartialArts] 2 9
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 5
//[GuiMartialArts] 63 100
//[GuiMartialArts] 64 0.9
//[GuiMartialArts] 66 83
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 680
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 56
//[GuiMartialArts] 104 5056
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 9
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0.9
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&4.5|64&1.3|65&0.9
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 9
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 8
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0.3
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.3
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 1.75
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0.3
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 1
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 1
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0.3
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0.3
//[GuiMartialArts] 98 45
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ901 100 0 0
//[GuiMartialArts] 0 ʯƪ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 57
//[GuiMartialArts] 104 5057
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 9
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0.1
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.45|62&0.7|65&0.3|507&0.65
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 20
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0.1
//[GuiMartialArts] 50096 0.1
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 60
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ902 100 0 10
//[GuiMartialArts] 0 ʩ˷ƪ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 58
//[GuiMartialArts] 104 5058
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 9
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0.2
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.65|62&0.8|65&0.35|507&1
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 1
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 1
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 30
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0.1
//[GuiMartialArts] 51368 0.1
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 60
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ903 100 0 0
//[GuiMartialArts] 0 ѱƪ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 59
//[GuiMartialArts] 104 5059
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 9
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0.3
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1|62&0.9|65&0.4|507&1.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 20
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0.5
//[GuiMartialArts] 50033 0.5
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0.2
//[GuiMartialArts] 51108 0.2
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 60
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ904 100 0 0
//[GuiMartialArts] 0 ǧƪ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 60
//[GuiMartialArts] 104 5060
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 9
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0.4
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.35|62&1|65&0.45|507&2
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 4
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 2
//[GuiMartialArts] 923 4
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 30
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0.75
//[GuiMartialArts] 50033 0.75
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0.75
//[GuiMartialArts] 50086 0.75
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 60
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ905 100 0 0
//[GuiMartialArts] 0 ƪ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 61
//[GuiMartialArts] 104 5061
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 9
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0.5
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.7|62&1.1|65&0.5|507&2.5
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 7
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.75
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.75
//[GuiMartialArts] 50072 0.75
//[GuiMartialArts] 50073 0.75
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0.3
//[GuiMartialArts] 50096 0.3
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 60
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1001 100 0 0
//[GuiMartialArts] 0 ᪻Ҫ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ԪѨ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 62
//[GuiMartialArts] 104 5062
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 10
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0.02
//[GuiMartialArts] 702 0.02
//[GuiMartialArts] 703 0.02
//[GuiMartialArts] 704 0.02
//[GuiMartialArts] 705 0.02
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.5|62&0.25|64&0.25|65&0.5|509&0.55|510&0.55
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 1
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 3
//[GuiMartialArts] 922 2
//[GuiMartialArts] 923 4
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0.5
//[GuiMartialArts] 51110 0.5
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1002 100 0 0
//[GuiMartialArts] 0 ũҪ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ȪѨ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 63
//[GuiMartialArts] 104 5063
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 10
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0.2
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.75|62&0.3|64&0.3|65&0.55|509&0.8|510&0.8
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 1
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 1
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 2
//[GuiMartialArts] 922 1
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 7
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0.5
//[GuiMartialArts] 50033 0.5
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 75
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1003 100 0 0
//[GuiMartialArts] 0 ɽҾ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 ӿȪѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 64
//[GuiMartialArts] 104 5064
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 10
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0.3
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.15|62&0.35|64&0.35|65&0.6|509&1.25|510&1.25
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 1
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 3
//[GuiMartialArts] 922 2
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 9
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 1.5
//[GuiMartialArts] 51110 1.5
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 75
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1004 100 0 0
//[GuiMartialArts] 0 ķ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 ӭѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 65
//[GuiMartialArts] 104 5065
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 10
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0.4
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.5|62&0.4|64&0.4|65&0.65|509&1.65|510&1.65
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 1
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 4
//[GuiMartialArts] 924 7
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0.5
//[GuiMartialArts] 50042 0.5
//[GuiMartialArts] 50043 0.5
//[GuiMartialArts] 50044 0.5
//[GuiMartialArts] 50045 0.5
//[GuiMartialArts] 50046 0.5
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.75
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0.2
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 75
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1005 100 0 0
//[GuiMartialArts] 0 Ŷ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ǿѨ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 66
//[GuiMartialArts] 104 5066
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 10
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0.5
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.9|62&0.45|64&0.45|65&0.7|509&2.1|510&2.1
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 1
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 1
//[GuiMartialArts] 906 1
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 1
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 1
//[GuiMartialArts] 922 1
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 8
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 1
//[GuiMartialArts] 50033 1
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 1.25
//[GuiMartialArts] 51110 1.25
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.5
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 75
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1101 100 0 0
//[GuiMartialArts] 0 ļз
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 67
//[GuiMartialArts] 104 5067
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0.1
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.6|62&0.55|66&0.45|514&0.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 1
//[GuiMartialArts] 923 8
//[GuiMartialArts] 924 3
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0.1
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0.1
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 15
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1102 100 0 0
//[GuiMartialArts] 0 ķ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 68
//[GuiMartialArts] 104 5068
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0.2
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.9|62&0.45|64&0.35|66&0.35|514&0.75
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 2
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.1
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 15
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1103 100 0 0
//[GuiMartialArts] 0 ܺӦ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 ú
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 69
//[GuiMartialArts] 104 5069
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0.06
//[GuiMartialArts] 702 0.06
//[GuiMartialArts] 703 0.06
//[GuiMartialArts] 704 0.06
//[GuiMartialArts] 705 0.06
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.35|62&0.5|64&0.4|66&0.4|514&1.15
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.5
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0.1
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1104 100 0 0
//[GuiMartialArts] 0 ƿ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 70
//[GuiMartialArts] 104 5070
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0.08
//[GuiMartialArts] 702 0.08
//[GuiMartialArts] 703 0.08
//[GuiMartialArts] 704 0.08
//[GuiMartialArts] 705 0.08
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.8|62&0.65|64&0.5|66&0.3|514&1.5
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 1
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 1
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0.15
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.25
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.25
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0.2
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1105 100 0 0
//[GuiMartialArts] 0 չඥ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 71
//[GuiMartialArts] 104 5071
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0.5
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.3|62&0.8|66&0.8|514&1.9
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 7
//[GuiMartialArts] 922 2
//[GuiMartialArts] 923 8
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 1
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.2
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0.2
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0.2
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 15
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1106 100 0 0
//[GuiMartialArts] 0 վ
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 ú
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 72
//[GuiMartialArts] 104 5072
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0.6
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.75|62&0.55|64&0.55|66&0.65|514&2.3
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 1
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 2
//[GuiMartialArts] 923 7
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.2
//[GuiMartialArts] 50082 0.2
//[GuiMartialArts] 50083 0.75
//[GuiMartialArts] 51367 0.15
//[GuiMartialArts] 51368 0.15
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0.3
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 15
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1107 100 0 0
//[GuiMartialArts] 0 ն
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 73
//[GuiMartialArts] 104 5073
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0.7
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&3.2|62&0.75|64&0.6|66&0.55|514&2.65
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 9
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.4
//[GuiMartialArts] 50082 0.4
//[GuiMartialArts] 50083 1.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0.3
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 15
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1108 100 0 0
//[GuiMartialArts] 0 Ħڭ޻
//[GuiMartialArts] 2 8
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 90
//[GuiMartialArts] 64 0.8
//[GuiMartialArts] 66 66
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 545
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 74
//[GuiMartialArts] 104 5074
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 8
//[GuiMartialArts] 701 0.8
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&3.65|61&1.1|62&0.6|66&0.35|514&3.05
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 8
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 7
//[GuiMartialArts] 924 7
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.3
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 -0.4
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.3
//[GuiMartialArts] 50082 0.3
//[GuiMartialArts] 50083 0.5
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1.75
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0.3
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0.3
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0.3
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 15
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1109 100 0 0
//[GuiMartialArts] 0 ٤
//[GuiMartialArts] 2 9
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 5
//[GuiMartialArts] 63 100
//[GuiMartialArts] 64 0.9
//[GuiMartialArts] 66 83
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 680
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 75
//[GuiMartialArts] 104 5075
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 9
//[GuiMartialArts] 701 0.9
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&4.15|62&1.4|64&0.4|66&0.4|514&3.45
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 1
//[GuiMartialArts] 909 1
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 4.5
//[GuiMartialArts] 50033 4.5
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1.5
//[GuiMartialArts] 50072 1.5
//[GuiMartialArts] 50073 1.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 15
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1201 100 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 ȪѨ
//[GuiMartialArts] 71 ͹Ѩ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 76
//[GuiMartialArts] 104 5076
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.1
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.45|62&0.25|63&0.25|65&0.5|510&0.65
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 2
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0.5
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1202 100 0 0
//[GuiMartialArts] 0 ɷ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 77
//[GuiMartialArts] 104 5077
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.2
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.65|63&0.4|64&0.4|65&0.35|510&1
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 5
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 7
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0.5
//[GuiMartialArts] 51110 1
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0.1
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1203 100 0 0
//[GuiMartialArts] 0 ɷ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 иѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 78
//[GuiMartialArts] 104 5078
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.3
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1|61&0.7|65&0.6|510&1.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 7
//[GuiMartialArts] 923 2
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 1
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.2
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0.1
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1204 100 0 0
//[GuiMartialArts] 0 ɷ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 жѨ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 79
//[GuiMartialArts] 104 5079
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.4
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.35|62&0.8|65&0.65|510&2
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 5
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0.75
//[GuiMartialArts] 51110 1.25
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.5
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1205 100 0 0
//[GuiMartialArts] 0 ɷ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ٸѨ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 80
//[GuiMartialArts] 104 5080
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.5
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.7|63&0.9|65&0.7|510&2.5
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 9
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 1.25
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.2
//[GuiMartialArts] 50083 0.75
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.75
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0.2
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1206 100 0 0
//[GuiMartialArts] 0 깦
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 ȱѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 81
//[GuiMartialArts] 104 5081
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0.6
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.05|63&0.75|65&1|510&3
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 8
//[GuiMartialArts] 923 4
//[GuiMartialArts] 924 7
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 2.25
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.1
//[GuiMartialArts] 51107 0.3
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.3
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.75
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0.2
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 30
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1207 100 0 0
//[GuiMartialArts] 0 а
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 82
//[GuiMartialArts] 104 5082
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0.14
//[GuiMartialArts] 702 0.14
//[GuiMartialArts] 703 0.14
//[GuiMartialArts] 704 0.14
//[GuiMartialArts] 705 0.14
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.4|62&0.4|64&0.4|65&1.1|510&3.5
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 2
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 2
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 2
//[GuiMartialArts] 50042 2
//[GuiMartialArts] 50043 2
//[GuiMartialArts] 50044 2
//[GuiMartialArts] 50045 2
//[GuiMartialArts] 50046 2
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.1
//[GuiMartialArts] 51102 0.1
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 1
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0.3
//[GuiMartialArts] 50094 0.3
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1301 100 0 0
//[GuiMartialArts] 0 ͼ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ȻѨ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 83
//[GuiMartialArts] 104 5083
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 13
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0.1
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.5|63&0.6|65&0.4|505&0.6
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 2
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 2
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 3
//[GuiMartialArts] 922 6
//[GuiMartialArts] 923 1
//[GuiMartialArts] 924 2
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.1
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0.1
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 45
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1302 100 0 0
//[GuiMartialArts] 0 ԰
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 84
//[GuiMartialArts] 104 5084
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 13
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0.2
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.75|64&0.65|65&0.5|505&0.9
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 1
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 1
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 3
//[GuiMartialArts] 922 5
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 -0.05
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.5
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0.1
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.25
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 45
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1303 100 0 4
//[GuiMartialArts] 0 ʮ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 ȻѨ
//[GuiMartialArts] 71 ӭѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 85
//[GuiMartialArts] 104 5085
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 13
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0.3
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.15|63&0.6|65&0.7|505&1.35
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 2
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 2
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 3
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.1
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 1
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0.2
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 45
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1304 100 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 86
//[GuiMartialArts] 104 5086
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 13
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0.4
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.5|63&0.7|65&0.75|505&1.8
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 2
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 2
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 1
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 2
//[GuiMartialArts] 922 6
//[GuiMartialArts] 923 1
//[GuiMartialArts] 924 3
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.2
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 1.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 45
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1305 100 0 0
//[GuiMartialArts] 0 ڤ澭
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 87
//[GuiMartialArts] 104 5087
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 13
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0.5
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.9|64&0.8|65&0.8|505&2.3
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 7
//[GuiMartialArts] 922 8
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 1.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0.2
//[GuiMartialArts] 50096 0.2
//[GuiMartialArts] 50097 0.2
//[GuiMartialArts] 50098 0.2
//[GuiMartialArts] 98 45
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1306 100 0 0
//[GuiMartialArts] 0 ͼ
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 88
//[GuiMartialArts] 104 5088
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 13
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0.6
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.3|63&0.75|65&1|505&2.75
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 3
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 2
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 1
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 5
//[GuiMartialArts] 923 2
//[GuiMartialArts] 924 3
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 1
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 -0.1
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0.2
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.3
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.75
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 1.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0.3
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 45
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1401 100 0 0
//[GuiMartialArts] 0 ᷨ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 β
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 89
//[GuiMartialArts] 104 5089
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0.1
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.65|61&0.4|62&0.6
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 2
//[GuiMartialArts] 923 8
//[GuiMartialArts] 924 3
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 30
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.1
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.1
//[GuiMartialArts] 50082 0.1
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0.1
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 60
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1402 100 0 0
//[GuiMartialArts] 0 ̻
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 90
//[GuiMartialArts] 104 5090
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0.2
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1|61&0.5|62&0.65
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.1
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0.1
//[GuiMartialArts] 98 60
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1403 100 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 άѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 91
//[GuiMartialArts] 104 5091
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0.3
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.5|61&0.85|64&0.45
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 7
//[GuiMartialArts] 922 5
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 3
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0.2
//[GuiMartialArts] 50098 0.2
//[GuiMartialArts] 98 60
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1404 100 0 0
//[GuiMartialArts] 0 С
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 ǿѨ
//[GuiMartialArts] 71 ̨Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 92
//[GuiMartialArts] 104 5092
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0.4
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2|64&0.65|65&0.8
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 1
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 1
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0.75
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.1
//[GuiMartialArts] 51102 0.1
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.75
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0.2
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 60
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1405 100 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 93
//[GuiMartialArts] 104 5093
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0.5
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.5|61&1.6
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 8
//[GuiMartialArts] 922 7
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 -0.1
//[GuiMartialArts] 51105 -0.3
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.2
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.75
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0.3
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0.3
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 60
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1406 100 0 0
//[GuiMartialArts] 0 һ
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ޹Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 94
//[GuiMartialArts] 104 5094
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0.6
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&3|61&1|62&0.75
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 4
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 1
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 -0.1
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0.3
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.2
//[GuiMartialArts] 50083 1
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0.3
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0.3
//[GuiMartialArts] 98 60
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1407 100 0 0
//[GuiMartialArts] 0 ħ
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 ʢŭ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 95
//[GuiMartialArts] 104 5095
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0.7
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&3.5|61&1.1|62&0.8
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 8
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.2
//[GuiMartialArts] 51102 0.2
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1.5
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 1.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0.3
//[GuiMartialArts] 50098 0.3
//[GuiMartialArts] 98 60
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1408 100 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 8
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 90
//[GuiMartialArts] 64 0.8
//[GuiMartialArts] 66 66
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 545
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 96
//[GuiMartialArts] 104 5096
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 8
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0.8
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&4|61&1.25|64&0.8
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 2
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 3
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 2.5
//[GuiMartialArts] 50033 2.5
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 -0.15
//[GuiMartialArts] 51104 -0.15
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 1.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0.3
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 1
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 60
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1501 100 0 4
//[GuiMartialArts] 0 ĸ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ԨҸѨ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 97
//[GuiMartialArts] 104 5097
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0.1
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.55|61&0.6|63&0.4|510&0.55
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 4
//[GuiMartialArts] 924 5
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0.25
//[GuiMartialArts] 50033 0.25
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 75
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1502 100 0 0
//[GuiMartialArts] 0 ʬľ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 ḡ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 98
//[GuiMartialArts] 104 5098
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0.2
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&0.8|61&0.7|63&0.45|510&0.8
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 5
//[GuiMartialArts] 922 4
//[GuiMartialArts] 923 4
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.2
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0.1
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 75
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1503 100 0 0
//[GuiMartialArts] 0 а
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 ׶
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 99
//[GuiMartialArts] 104 5099
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0.3
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.25|61&0.8|64&0.5|510&1.25
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 2
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 2
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 4
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.2
//[GuiMartialArts] 50083 0.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0.1
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 75
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1504 100 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 ̰
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 100
//[GuiMartialArts] 104 5100
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0.08
//[GuiMartialArts] 702 0.08
//[GuiMartialArts] 703 0.08
//[GuiMartialArts] 704 0.08
//[GuiMartialArts] 705 0.08
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&1.65|61&0.9|62&0.55|510&1.65
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 7
//[GuiMartialArts] 922 5
//[GuiMartialArts] 923 3
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.1
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0.2
//[GuiMartialArts] 50096 0.2
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 0
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1505 100 0 0
//[GuiMartialArts] 0 ̫
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ӭѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 101
//[GuiMartialArts] 104 5101
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0.5
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.1|62&0.95|64&0.65|510&2.1
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 3
//[GuiMartialArts] 923 6
//[GuiMartialArts] 924 7
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 2
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.1
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.3
//[GuiMartialArts] 50082 0.3
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0.2
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 75
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1506 100 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 ɫ
//[GuiMartialArts] 71 ʶ
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 102
//[GuiMartialArts] 104 5102
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0.6
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.5|61&0.6|63&0.55|64&0.6|510&2.5
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 4
//[GuiMartialArts] 921 4
//[GuiMartialArts] 922 5
//[GuiMartialArts] 923 2
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 2
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 1
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0.2
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0.2
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 75
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1507 100 0 0
//[GuiMartialArts] 0 ͯѪ
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 ¼
//[GuiMartialArts] 71 צ
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 103
//[GuiMartialArts] 104 5103
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0.7
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&2.95|61&0.4|62&0.9|64&0.6|510&2.95
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 2
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 2
//[GuiMartialArts] 923 7
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 1.75
//[GuiMartialArts] 50033 1.75
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0.75
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0.1
//[GuiMartialArts] 51371 0.1
//[GuiMartialArts] 51372 0.1
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0.3
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 75
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1508 100 0 0
//[GuiMartialArts] 0 Ѫа
//[GuiMartialArts] 2 8
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 90
//[GuiMartialArts] 64 0.8
//[GuiMartialArts] 66 66
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ԻѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 545
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 104
//[GuiMartialArts] 104 5104
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 8
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0.8
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&3.35|61&1.1|62&0.45|65&0.5|510&3.35
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 1
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 1
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 1
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 1
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 6
//[GuiMartialArts] 922 2
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 6
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 1
//[GuiMartialArts] 50042 1
//[GuiMartialArts] 50043 1
//[GuiMartialArts] 50044 1
//[GuiMartialArts] 50045 1
//[GuiMartialArts] 50046 1
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.4
//[GuiMartialArts] 50082 0.4
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0.15
//[GuiMartialArts] 51368 0.15
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1
//[GuiMartialArts] 50072 1
//[GuiMartialArts] 50073 1
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0.3
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 75
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ1509 100 0 0
//[GuiMartialArts] 0 Ѫͯ
//[GuiMartialArts] 2 9
//[GuiMartialArts] 61 101
//[GuiMartialArts] 62 5
//[GuiMartialArts] 63 100
//[GuiMartialArts] 64 0.9
//[GuiMartialArts] 66 83
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 ٻѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 680
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 105
//[GuiMartialArts] 104 5105
//[GuiMartialArts] 1 0
//[GuiMartialArts] 6 0
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 9
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0.9
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 601&3.8|61&1.3|65&0.9|510&3.8
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 7
//[GuiMartialArts] 922 5
//[GuiMartialArts] 923 5
//[GuiMartialArts] 924 9
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 1.5
//[GuiMartialArts] 50033 1.5
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 1.25
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1.75
//[GuiMartialArts] 50072 1.75
//[GuiMartialArts] 50073 1.75
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0.3
//[GuiMartialArts] 50096 0.3
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 75
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10101 0 0 0
//[GuiMartialArts] 0 ݹ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 賦
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 401
//[GuiMartialArts] 104 5401
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.5|63&0.25|66&0.75|514&0.6
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 6
//[GuiMartialArts] 8 30
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 100
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.6
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.25
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.25
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10102 0 0 0
//[GuiMartialArts] 0 ڻǽ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 1|5|6
//[GuiMartialArts] 70 С
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 402
//[GuiMartialArts] 104 5402
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.75|63&0.3|66&0.85|514&0.9
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 3
//[GuiMartialArts] 8 30
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 50
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.6
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.25
//[GuiMartialArts] 50085 0.25
//[GuiMartialArts] 50086 0.25
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 16
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10103 5 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 1|5|6
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ϪѨ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 403
//[GuiMartialArts] 104 5403
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.15|63&0.35|66&0.95|514&1.35
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 90
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.4
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.4
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 -0.05
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.75
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10104 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 0|1|5|6
//[GuiMartialArts] 70 в
//[GuiMartialArts] 71 ƹ
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 404
//[GuiMartialArts] 104 5404
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.5|63&0.45|66&1|514&1.8
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 30
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 300
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.6
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.6
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 16
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10105 0 0 0
//[GuiMartialArts] 0 ͼ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 405
//[GuiMartialArts] 104 5405
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.9|66&1.6|514&2.3
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 4
//[GuiMartialArts] 8 30
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 130
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0.4
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0.4
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.75
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.75
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 16
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10106 0 0 0
//[GuiMartialArts] 0 һέɽ
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 1|5|6
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 зѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 406
//[GuiMartialArts] 104 5406
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2.3|63&0.5|66&1.25|514&2.75
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 3
//[GuiMartialArts] 10 130
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 1
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.2
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 1.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10201 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 ƹ
//[GuiMartialArts] 71 㸹
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 407
//[GuiMartialArts] 104 5407
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.55|63&0.35|65&0.2|66&0.45|513&0.5|514&0.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 7
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 120
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0.7
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.05
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.25
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 31
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10202 0 0 0
//[GuiMartialArts] 0 Գ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 0|1|5|6
//[GuiMartialArts] 70 t
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 408
//[GuiMartialArts] 104 5408
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.8|63&0.8|66&0.35|513&0.75|514&0.75
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 3
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 70
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0.7
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.1
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.25
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.25
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 31
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10203 0 0 0
//[GuiMartialArts] 0 ޶
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 ˮ
//[GuiMartialArts] 71 ˮ
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 409
//[GuiMartialArts] 104 5409
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.25|63&0.5|65&0.3|66&0.5|513&1.15|514&1.15
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 50
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.6
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.6
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0.75
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10204 0 0 0
//[GuiMartialArts] 0 ŮŲ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 1
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ̫ϪѨ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 410
//[GuiMartialArts] 104 5410
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.65|63&0.85|66&0.6|513&1.5|514&1.5
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 60
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.3
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.5
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 31
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10205 100 0 0
//[GuiMartialArts] 0 Ů
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 ط
//[GuiMartialArts] 71 ع
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 411
//[GuiMartialArts] 104 5411
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2.1|63&0.9|65&0.35|66&0.35|513&1.9|514&1.9
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 11
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 110
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.5
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.3
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.2
//[GuiMartialArts] 51107 0.1
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.75
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 31
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10206 0 0 0
//[GuiMartialArts] 0 ǧ̶ӡ²
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 ˮ
//[GuiMartialArts] 71 ˮ
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 412
//[GuiMartialArts] 104 5412
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2.5|63&1|66&0.75|513&2.3|514&2.3
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 80
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0.4
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0.4
//[GuiMartialArts] 36 6
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 1
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 1
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 31
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10207 0 0 0
//[GuiMartialArts] 0 𶥷
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ȻѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 413
//[GuiMartialArts] 104 5413
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2.95|63&1.2|66&0.7|513&2.65|514&2.65
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 11
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 3
//[GuiMartialArts] 10 340
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.4
//[GuiMartialArts] 33 0.7
//[GuiMartialArts] 34 0.4
//[GuiMartialArts] 35 0.7
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.2
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 1
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 31
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10301 22 0 0
//[GuiMartialArts] 0 뷨
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 С
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 414
//[GuiMartialArts] 104 5414
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.6|63&0.5|65&0.25|66&0.25|509&0.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 40
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0.4
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0.4
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.1
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.25
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10302 0 0 0
//[GuiMartialArts] 0 ǣţ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 415
//[GuiMartialArts] 104 5415
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.9|63&0.55|65&0.3|66&0.3|509&0.75
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 160
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.5
//[GuiMartialArts] 33 0.5
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 46
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10303 25 0 0
//[GuiMartialArts] 0 봩
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 С
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 416
//[GuiMartialArts] 104 5416
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.35|63&0.6|65&0.35|66&0.35|509&1.15
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 8
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 180
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0.8
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0.1
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.1
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 46
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10304 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 417
//[GuiMartialArts] 104 5417
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.8|63&0.65|65&0.4|66&0.4|509&1.5
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 80
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0.4
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0.4
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 46
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10305 0 0 0
//[GuiMartialArts] 0 ̤ѩѰ÷
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 ¶
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 418
//[GuiMartialArts] 104 5418
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2.3|63&0.7|65&0.45|66&0.45|509&1.9
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 130
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.4
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.4
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 -0.05
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.75
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.75
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 46
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10306 0 0 0
//[GuiMartialArts] 0 յ˿
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 ˮ
//[GuiMartialArts] 71 â
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 419
//[GuiMartialArts] 104 5419
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2.75|63&0.75|65&0.5|66&0.5|509&2.3
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 180
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.7
//[GuiMartialArts] 33 0.7
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.1
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.2
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 46
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10307 0 0 0
//[GuiMartialArts] 0 ֥
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 С
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 420
//[GuiMartialArts] 104 5420
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&3.2|63&0.8|65&0.55|66&0.55|509&2.65
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 3
//[GuiMartialArts] 10 80
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.5
//[GuiMartialArts] 35 0.5
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.2
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.2
//[GuiMartialArts] 51107 0.2
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10401 0 0 0
//[GuiMartialArts] 0 岽÷׮
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 ľ
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 422
//[GuiMartialArts] 104 5422
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.55|62&0.3|63&0.3|66&0.4|513&0.55
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 3
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 140
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.4
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.4
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10402 0 0 0
//[GuiMartialArts] 0 Բ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 Ǭ
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 423
//[GuiMartialArts] 104 5423
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.8|62&0.35|63&0.35|66&0.45|513&0.8
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 160
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0.5
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0.5
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10403 0 0 0
//[GuiMartialArts] 0 ƻ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 424
//[GuiMartialArts] 104 5424
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.25|63&0.75|66&0.55|513&1.25
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 5
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 70
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.2
//[GuiMartialArts] 33 0.3
//[GuiMartialArts] 34 0.2
//[GuiMartialArts] 35 0.3
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.1
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10404 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 425
//[GuiMartialArts] 104 5425
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.65|62&0.4|63&0.4|66&0.65|513&1.65
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 180
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.4
//[GuiMartialArts] 33 0.4
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 61
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10405 0 0 0
//[GuiMartialArts] 0 ̫ҾŹ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 й
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 426
//[GuiMartialArts] 104 5426
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2.1|63&0.8|66&0.8|513&2.1
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 230
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.4
//[GuiMartialArts] 35 0.4
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.75
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 61
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10406 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 1|5|6
//[GuiMartialArts] 70 ̫Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 427
//[GuiMartialArts] 104 5427
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2.5|62&0.45|63&0.45|66&0.85|513&2.5
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 180
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.9
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.1
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 1
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10407 0 0 0
//[GuiMartialArts] 0 Ʒɶ
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 ϪѨ
//[GuiMartialArts] 71 ̫Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 428
//[GuiMartialArts] 104 5428
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2.95|62&0.5|63&0.5|66&0.9|513&2.95
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 13
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 3
//[GuiMartialArts] 10 80
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.9
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 1
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.2
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.75
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 61
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10501 0 0 0
//[GuiMartialArts] 0 ʯ׮
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 ׹
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 429
//[GuiMartialArts] 104 5429
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 5
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.65|62&0.45|66&0.55
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 20
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 100
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.3
//[GuiMartialArts] 35 0.4
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.1
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.25
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.25
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 76
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10502 0 0 0
//[GuiMartialArts] 0 ͻɽʽ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 1|5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 430
//[GuiMartialArts] 104 5430
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 5
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1|62&0.55|66&0.6
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 2
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 20
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.4
//[GuiMartialArts] 35 0.3
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0.1
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.25
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.25
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 76
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10503 0 0 0
//[GuiMartialArts] 0 ǧ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 ë
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 431
//[GuiMartialArts] 104 5431
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 5
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.5|62&0.65|66&0.65
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 20
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 170
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.5
//[GuiMartialArts] 35 0.5
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.75
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.75
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 76
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10601 0 0 0
//[GuiMartialArts] 0 ɽ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 ¹
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 433
//[GuiMartialArts] 104 5433
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 6
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.65|61&1
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 100
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.6
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 16
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10602 20 0 0
//[GuiMartialArts] 0 Ź
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 1
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 в
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 434
//[GuiMartialArts] 104 5434
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 6
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1|61&1.15
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 50
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.6
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 16
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10603 0 0 0
//[GuiMartialArts] 0 Ὥ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 1|5|6
//[GuiMartialArts] 70 ϥ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 435
//[GuiMartialArts] 104 5435
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 6
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.5|61&1.3
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 210
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.4
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 6
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 16
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10604 0 0 0
//[GuiMartialArts] 0 ʨӷѸ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 0|1|5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 436
//[GuiMartialArts] 104 5436
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 6
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2|61&1.45
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 3
//[GuiMartialArts] 10 130
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.8
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.1
//[GuiMartialArts] 51107 0.1
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.75
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.75
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 16
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10701 100 0 4
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 η
//[GuiMartialArts] 71 ˮ֮
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 437
//[GuiMartialArts] 104 5437
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.5|63&0.3|65&0.7|505&0.55|516&0.55
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 120
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.7
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.1
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 31
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10702 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 Ĺ
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 438
//[GuiMartialArts] 104 5438
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.75|63&0.35|65&0.8|505&0.8|516&0.8
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 3
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 70
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.7
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.1
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 31
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10703 0 0 0
//[GuiMartialArts] 0 ޲
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 w
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 439
//[GuiMartialArts] 104 5439
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.15|65&0.95|66&0.35|505&1.25|516&1.25
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 5
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 230
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.6
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.1
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10704 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 ͨ
//[GuiMartialArts] 71 Ӧ
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 440
//[GuiMartialArts] 104 5440
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.5|64&0.35|65&1.1|505&1.65|516&1.65
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 80
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.4
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.4
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.1
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.2
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 31
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10705 0 0 0
//[GuiMartialArts] 0 ٲ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 ̰
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 441
//[GuiMartialArts] 104 5441
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.9|63&0.4|65&1.2|505&2.1|516&2.1
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 30
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0.4
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0.4
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.1
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 1
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 31
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10706 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 ӷ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 442
//[GuiMartialArts] 104 5442
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2.3|65&1.35|66&0.4|505&2.5|516&2.5
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 9
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 3
//[GuiMartialArts] 10 550
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 1.2
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0.3
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 1
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 31
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10707 25 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 ν
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 443
//[GuiMartialArts] 104 5443
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2.65|64&0.45|65&1.45|505&2.95|516&2.95
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 3
//[GuiMartialArts] 10 100
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.3
//[GuiMartialArts] 33 0.3
//[GuiMartialArts] 34 0.3
//[GuiMartialArts] 35 0.3
//[GuiMartialArts] 36 6
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.3
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 1
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10801 100 0 0
//[GuiMartialArts] 0 ÷ͷ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 444
//[GuiMartialArts] 104 5444
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.65|63&0.65|64&0.35
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 3
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 40
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0.4
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0.4
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.1
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.25
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 46
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10802 100 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 ˮг
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 445
//[GuiMartialArts] 104 5445
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1|63&0.75|64&0.4
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 60
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0.5
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0.5
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 46
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10803 100 0 0
//[GuiMartialArts] 0 벽
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 Ӿĸ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 446
//[GuiMartialArts] 104 5446
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.5|63&0.8|65&0.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 10
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 50
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.2
//[GuiMartialArts] 33 0.3
//[GuiMartialArts] 34 0.2
//[GuiMartialArts] 35 0.3
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 46
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10804 100 0 0
//[GuiMartialArts] 0 ϼ˲
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 ȸͶ
//[GuiMartialArts] 71 õ
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 447
//[GuiMartialArts] 104 5447
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2|63&0.9|65&0.55
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 100
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0.6
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0.1
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0.2
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 46
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10805 0 0 0
//[GuiMartialArts] 0 ϶
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 1|5|6
//[GuiMartialArts] 70 ׳
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 448
//[GuiMartialArts] 104 5448
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2.5|63&1.2|64&0.4
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 130
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 1
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0.3
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 46
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10806 0 0 0
//[GuiMartialArts] 0 ̤ѩ
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 ˮ
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 449
//[GuiMartialArts] 104 5449
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&3|63&1.3|64&0.45
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 140
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0.6
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0.75
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 46
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10807 0 0 0
//[GuiMartialArts] 0 Ůı
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 1|5|6
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 պѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 450
//[GuiMartialArts] 104 5450
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&3.5|63&1.4|64&0.5
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 3
//[GuiMartialArts] 10 20
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 1
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.1
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 1.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 46
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10808 0 0 0
//[GuiMartialArts] 0 貨
//[GuiMartialArts] 2 8
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 90
//[GuiMartialArts] 64 0.8
//[GuiMartialArts] 66 66
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 1|5|6
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 545
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 451
//[GuiMartialArts] 104 5451
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 8
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&4|63&1.5|65&0.55
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 14
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 3
//[GuiMartialArts] 10 150
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0.6
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0.4
//[GuiMartialArts] 36 6
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.2
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 46
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10809 100 0 0
//[GuiMartialArts] 0 ¹
//[GuiMartialArts] 2 9
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 5
//[GuiMartialArts] 63 100
//[GuiMartialArts] 64 0.9
//[GuiMartialArts] 66 83
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 680
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 452
//[GuiMartialArts] 104 5452
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 9
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&4.5|63&1.6|64&0.6
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 12
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 3
//[GuiMartialArts] 10 100
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0.4
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0.6
//[GuiMartialArts] 36 6
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.75
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.1
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0.75
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 46
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10901 0 0 0
//[GuiMartialArts] 0 ľĹ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 ֺ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 453
//[GuiMartialArts] 104 5453
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 9
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.45|62&0.7|65&0.3|507&0.65
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 3
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 100
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.3
//[GuiMartialArts] 33 0.3
//[GuiMartialArts] 34 0.3
//[GuiMartialArts] 35 0.3
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 61
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10902 0 0 0
//[GuiMartialArts] 0 Ԧƪ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 l
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 454
//[GuiMartialArts] 104 5454
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 9
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.65|62&0.8|65&0.35|507&1
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 90
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.4
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.4
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10903 0 0 0
//[GuiMartialArts] 0 ˷ʽ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 Ҷ
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 455
//[GuiMartialArts] 104 5455
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 9
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1|62&0.9|65&0.4|507&1.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 20
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 160
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0.5
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0.5
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.1
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0.3
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 1
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ10904 0 0 0
//[GuiMartialArts] 0 Խ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 붫
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 456
//[GuiMartialArts] 104 5456
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 9
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.35|62&1|65&0.45|507&2
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 4
//[GuiMartialArts] 8 20
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 40
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.2
//[GuiMartialArts] 33 0.2
//[GuiMartialArts] 34 0.2
//[GuiMartialArts] 35 0.2
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 1
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 1
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 61
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11001 0 0 0
//[GuiMartialArts] 0 Ϸ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ݹѨ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 458
//[GuiMartialArts] 104 5458
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 10
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.65|62&0.25|63&0.5|64&0.25
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 90
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.4
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.4
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.75
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11002 0 0 0
//[GuiMartialArts] 0 Σ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 1|5|6
//[GuiMartialArts] 70 º
//[GuiMartialArts] 71 Ȼ
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 459
//[GuiMartialArts] 104 5459
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 10
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1|62&0.3|63&0.55|64&0.3
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 3
//[GuiMartialArts] 8 20
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 190
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.4
//[GuiMartialArts] 33 0.4
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.75
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 76
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11003 0 0 0
//[GuiMartialArts] 0 ɳ̤ˮ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 ɽ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 460
//[GuiMartialArts] 104 5460
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 10
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.5|62&0.35|63&0.6|64&0.35
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 2
//[GuiMartialArts] 8 30
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 160
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.5
//[GuiMartialArts] 35 0.5
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.75
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 76
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11004 0 0 0
//[GuiMartialArts] 0 ɽһ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 1
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 461
//[GuiMartialArts] 104 5461
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 10
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2|62&0.4|63&0.65|64&0.4
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 240
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.2
//[GuiMartialArts] 33 0.2
//[GuiMartialArts] 34 0.3
//[GuiMartialArts] 35 0.3
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0.75
//[GuiMartialArts] 50086 0.75
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 76
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11101 0 0 0
//[GuiMartialArts] 0 ʯ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 ׹
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 463
//[GuiMartialArts] 104 5463
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.55|62&0.55|66&0.45|514&0.55
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 200
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.6
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 16
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11102 0 0 0
//[GuiMartialArts] 0 󶨽
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 464
//[GuiMartialArts] 104 5464
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.8|62&0.6|66&0.55|514&0.8
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 3
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 170
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.7
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 16
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11103 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 1
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 465
//[GuiMartialArts] 104 5465
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.25|62&0.65|66&0.65|514&1.25
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 230
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.8
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.2
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 16
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11104 0 0 0
//[GuiMartialArts] 0 ͨ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 Ŀ
//[GuiMartialArts] 71 Ԥ
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 466
//[GuiMartialArts] 104 5466
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.65|62&0.7|66&0.75|514&1.65
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 3
//[GuiMartialArts] 10 230
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.9
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.2
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 1.25
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 16
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11201 0 0 0
//[GuiMartialArts] 0 й
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 1
//[GuiMartialArts] 70 ֫
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 467
//[GuiMartialArts] 104 5467
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.65|63&0.55|64&0.45
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 30
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 50
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.5
//[GuiMartialArts] 33 0.4
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.05
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.25
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 31
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11202 0 0 0
//[GuiMartialArts] 0 ̶
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 賦
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 468
//[GuiMartialArts] 104 5468
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1|62&0.5|63&0.65
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 20
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 70
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.5
//[GuiMartialArts] 35 0.4
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.25
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11203 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 1|5|6
//[GuiMartialArts] 70 ׷
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 469
//[GuiMartialArts] 104 5469
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.5|61&0.6|63&0.7
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 8
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 80
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0.8
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.25
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 31
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11204 0 0 0
//[GuiMartialArts] 0 ͷ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 2
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 470
//[GuiMartialArts] 104 5470
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2|63&0.8|64&0.65
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 4
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 180
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0.6
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 -0.05
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.25
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 31
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11205 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 471
//[GuiMartialArts] 104 5471
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2.5|63&0.9|65&0.7
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 30
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.4
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.4
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.75
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0.25
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 31
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11206 0 0 0
//[GuiMartialArts] 0 ݵذ
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 1|5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 ˹
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 472
//[GuiMartialArts] 104 5472
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&3|62&0.75|63&1
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 11
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 3
//[GuiMartialArts] 10 190
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.2
//[GuiMartialArts] 33 0.4
//[GuiMartialArts] 34 0.2
//[GuiMartialArts] 35 0.4
//[GuiMartialArts] 36 6
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.1
//[GuiMartialArts] 51102 0.1
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.75
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 31
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11207 0 0 0
//[GuiMartialArts] 0 ߷
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 1
//[GuiMartialArts] 70 ȱ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 473
//[GuiMartialArts] 104 5473
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&3.5|63&1.2|64&0.7
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 3
//[GuiMartialArts] 10 120
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0.5
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0.5
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.2
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0.25
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 31
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11301 0 0 0
//[GuiMartialArts] 0 ٳ׮
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 ľ
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 474
//[GuiMartialArts] 104 5474
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 13
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.6|63&0.6|65&0.4|505&0.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 100
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.8
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.25
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11302 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 º
//[GuiMartialArts] 71 ص
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 475
//[GuiMartialArts] 104 5475
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 13
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.9|63&0.7|65&0.45|505&0.75
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 3
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 130
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.8
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0.1
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.05
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 46
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11303 0 0 0
//[GuiMartialArts] 0 ǲ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 зѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 476
//[GuiMartialArts] 104 5476
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 13
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.35|63&0.75|65&0.55|505&1.15
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 110
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.6
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.6
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 1
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 46
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11305 0 0 0
//[GuiMartialArts] 0 峵
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 1|5|6
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ӿȪѨ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 478
//[GuiMartialArts] 104 5478
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 13
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2.3|63&0.9|64&0.7|505&1.9
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 50
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.7
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.1
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.75
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 46
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11401 0 0 0
//[GuiMartialArts] 0 Ź
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 483
//[GuiMartialArts] 104 5483
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.65|61&0.5|62&0.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 140
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.4
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.3
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.1
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 61
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11402 0 0 4
//[GuiMartialArts] 0 ɲ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 1|5|6
//[GuiMartialArts] 70 Ǭ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 484
//[GuiMartialArts] 104 5484
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1|63&0.65|65&0.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 15
//[GuiMartialArts] 8 20
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 40
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.3
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.4
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.75
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11403 0 0 0
//[GuiMartialArts] 0 β
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 0|1|5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 ¹
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 485
//[GuiMartialArts] 104 5485
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.5|61&0.8|62&0.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 130
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.8
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 61
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11404 0 0 0
//[GuiMartialArts] 0 Ծ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 0|1|5|6
//[GuiMartialArts] 70 Ϻ
//[GuiMartialArts] 71 ϥ
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 486
//[GuiMartialArts] 104 5486
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2|61&0.9|62&0.55
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 180
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.8
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 1
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 61
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11405 0 0 0
//[GuiMartialArts] 0 ξ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 0|1|5|6
//[GuiMartialArts] 70 ׵Ѩ
//[GuiMartialArts] 71 ǿѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 487
//[GuiMartialArts] 104 5487
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2.5|61&1|62&0.6
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 310
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.3
//[GuiMartialArts] 33 0.6
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0.1
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.1
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.75
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 61
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11406 0 0 0
//[GuiMartialArts] 0 Զ
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 ˮ
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 488
//[GuiMartialArts] 104 5488
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&3|61&0.7|62&0.5|63&0.55
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 15
//[GuiMartialArts] 8 30
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 3
//[GuiMartialArts] 10 110
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.3
//[GuiMartialArts] 35 0.6
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0.75
//[GuiMartialArts] 50086 0.75
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 1
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11501 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 3|4|5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 489
//[GuiMartialArts] 104 5489
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&0.65|61&0.25|63&0.75
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 3
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 90
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.4
//[GuiMartialArts] 33 0.4
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.1
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 76
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11502 88 0 0
//[GuiMartialArts] 0 ͷ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 3|4|5|6
//[GuiMartialArts] 70 ſ
//[GuiMartialArts] 71 ݵ
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 490
//[GuiMartialArts] 104 5490
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1|61&0.35|62&0.3|63&0.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 2
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 1
//[GuiMartialArts] 10 160
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.5
//[GuiMartialArts] 35 0.5
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 76
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11503 0 0 0
//[GuiMartialArts] 0 λ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 1|5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 491
//[GuiMartialArts] 104 5491
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&1.5|63&1|65&0.3
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 70
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.3
//[GuiMartialArts] 33 0.2
//[GuiMartialArts] 34 0.3
//[GuiMartialArts] 35 0.2
//[GuiMartialArts] 36 4
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 76
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11504 0 0 0
//[GuiMartialArts] 0 취
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 1|5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 N
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 492
//[GuiMartialArts] 104 5492
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2|61&0.45|62&0.45|63&0.55
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 2
//[GuiMartialArts] 8 30
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 200
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0.4
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0.4
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 6
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.1
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 76
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ11505 0 0 0
//[GuiMartialArts] 0 ʬ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 102
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 493
//[GuiMartialArts] 104 5493
//[GuiMartialArts] 1 1
//[GuiMartialArts] 6 2
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 602&2.5|61&0.5|63&1.1
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 2
//[GuiMartialArts] 10 130
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0.6
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0.6
//[GuiMartialArts] 36 2
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.1
//[GuiMartialArts] 51111 0.2
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 76
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20101 0 0 0
//[GuiMartialArts] 0 Ի
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 0|1|3|4|5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 201
//[GuiMartialArts] 104 5201
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.5|62&0.5|66&0.5|514&0.6
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0.25
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20102 0 0 0
//[GuiMartialArts] 0 մʮ˵
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 0|1|3|4|5|6
//[GuiMartialArts] 70 תŲ
//[GuiMartialArts] 71 ƶ
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 202
//[GuiMartialArts] 104 5202
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.75|63&0.4|66&0.75|514&0.9
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 20
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 90
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 3
//[GuiMartialArts] 47 3
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 3
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 400
//[GuiMartialArts] 55 350
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.25
//[GuiMartialArts] 50086 0.25
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20103 0 0 0
//[GuiMartialArts] 0 ǧ׹
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 1
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 203
//[GuiMartialArts] 104 5203
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.15|61&0.75|66&0.55|514&1.35
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 80
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 100
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 5
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0.5
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 1
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0.1
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20104 0 0 0
//[GuiMartialArts] 0 ͭ˷
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 0|1|2|3|4|5|6
//[GuiMartialArts] 70 賦
//[GuiMartialArts] 71 ͥ
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 204
//[GuiMartialArts] 104 5204
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.5|61&0.35|62&0.5|66&0.6|514&1.8
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0.5
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.1
//[GuiMartialArts] 50082 0.1
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.25
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20105 100 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 0|1
//[GuiMartialArts] 70 º
//[GuiMartialArts] 71 Ϻ
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 205
//[GuiMartialArts] 104 5205
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.9|62&0.95|66&0.65|514&2.3
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 30
//[GuiMartialArts] 9 80
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 140
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0.6
//[GuiMartialArts] 615 0.6
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 3
//[GuiMartialArts] 42 3
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0.2
//[GuiMartialArts] 53 0.2
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 350
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.3
//[GuiMartialArts] 50082 0.3
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20106 0 0 0
//[GuiMartialArts] 0 С޺
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 0|1|2|3|4|5|6
//[GuiMartialArts] 70 Բ
//[GuiMartialArts] 71 ɽ
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 206
//[GuiMartialArts] 104 5206
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.3|61&0.5|62&0.55|66&0.7|514&2.75
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.75
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20107 0 0 0
//[GuiMartialArts] 0 ʨӺ
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 2
//[GuiMartialArts] 70 춦Ѩ
//[GuiMartialArts] 71 زѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 207
//[GuiMartialArts] 104 5207
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.65|61&1.15|66&0.75|514&3.2
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 2
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0.1
//[GuiMartialArts] 50098 0.1
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20108 0 0 0
//[GuiMartialArts] 0 Ԫһ
//[GuiMartialArts] 2 8
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 90
//[GuiMartialArts] 64 0.8
//[GuiMartialArts] 66 66
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 545
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 208
//[GuiMartialArts] 104 5208
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 8
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&3.05|64&1.25|66&0.8|514&3.65
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 100
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 160
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 1.2
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 1.5
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0.4
//[GuiMartialArts] 54 200
//[GuiMartialArts] 55 600
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 2
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.4
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 1.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20109 0 0 0
//[GuiMartialArts] 0 ջ
//[GuiMartialArts] 2 9
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 5
//[GuiMartialArts] 63 100
//[GuiMartialArts] 64 0.9
//[GuiMartialArts] 66 83
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ٻѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 680
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 209
//[GuiMartialArts] 104 5209
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 1
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 9
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&3.45|62&1.3|66&0.9|514&4.15
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 100
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 180
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 1.2
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 1.5
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0.4
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 400
//[GuiMartialArts] 55 450
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 2
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.4
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20201 0 0 0
//[GuiMartialArts] 0 ü
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 0|1|5|6
//[GuiMartialArts] 70 ӿȪѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 210
//[GuiMartialArts] 104 5210
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.5|64&0.55|66&0.45|513&0.55|514&0.55
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.25
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20202 100 0 0
//[GuiMartialArts] 0 ޶
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 һĶ
//[GuiMartialArts] 71 ˼
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 211
//[GuiMartialArts] 104 5211
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.75|63&0.5|65&0.65|513&0.8|514&0.8
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.25
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.25
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20203 100 0 0
//[GuiMartialArts] 0 廨
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 0|1|2|3|4|5|6
//[GuiMartialArts] 70 о
//[GuiMartialArts] 71 ˷
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 212
//[GuiMartialArts] 104 5212
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.15|63&0.55|65&0.75|513&1.25|514&1.25
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.1
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.1
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20204 0 0 0
//[GuiMartialArts] 0 ޹
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 0|1|3|4|5|6
//[GuiMartialArts] 70 ƹ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 213
//[GuiMartialArts] 104 5213
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.5|63&0.6|64&0.35|66&0.5|513&1.65|514&1.65
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 70
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 5
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0.5
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.75
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0.1
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20205 0 0 0
//[GuiMartialArts] 0 徲һ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 214
//[GuiMartialArts] 104 5214
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.9|64&0.55|65&0.5|66&0.55|513&2.1|514&2.1
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.1
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20206 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 0|1|2|3|4|5|6
//[GuiMartialArts] 70 Բת
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 215
//[GuiMartialArts] 104 5215
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.3|63&0.7|64&0.45|66&0.6|513&2.5|514&2.5
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0.5
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.2
//[GuiMartialArts] 50082 0.2
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20207 0 0 0
//[GuiMartialArts] 0 ɹ
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 0|1
//[GuiMartialArts] 70 ¹Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 216
//[GuiMartialArts] 104 5216
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.65|64&0.65|65&0.6|66&0.65|513&2.95|514&2.95
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 80
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 90
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 5
//[GuiMartialArts] 42 5
//[GuiMartialArts] 43 0.5
//[GuiMartialArts] 44 0.5
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 1
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.3
//[GuiMartialArts] 50082 0.3
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20208 0 0 0
//[GuiMartialArts] 0 Ǻ
//[GuiMartialArts] 2 8
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 90
//[GuiMartialArts] 64 0.8
//[GuiMartialArts] 66 66
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ϹѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 545
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 217
//[GuiMartialArts] 104 5217
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 8
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&3.05|64&0.7|65&0.65|66&0.7|513&3.35|514&3.35
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 1
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0.5
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.2
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20209 0 0 0
//[GuiMartialArts] 0 ʥ
//[GuiMartialArts] 2 9
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 5
//[GuiMartialArts] 63 100
//[GuiMartialArts] 64 0.9
//[GuiMartialArts] 66 83
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 0|1
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 680
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 218
//[GuiMartialArts] 104 5218
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 2
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 9
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&3.45|64&0.75|65&0.7|66&0.75|513&3.8|514&3.8
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 80
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 160
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 1.5
//[GuiMartialArts] 49 1.5
//[GuiMartialArts] 50 1.5
//[GuiMartialArts] 51 6
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 400
//[GuiMartialArts] 55 450
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0.75
//[GuiMartialArts] 50086 0.75
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20301 0 0 0
//[GuiMartialArts] 0 ʮ뷨
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 3|4
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 219
//[GuiMartialArts] 104 5219
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.5|63&0.35|65&0.4|66&0.25|509&0.6
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20302 20 0 0
//[GuiMartialArts] 0 ±а
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 0|1
//[GuiMartialArts] 70 άѨ
//[GuiMartialArts] 71 ԨҸѨ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 220
//[GuiMartialArts] 104 5220
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.75|64&0.4|65&0.45|66&0.3|509&0.9
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0.5
//[GuiMartialArts] 50042 0.5
//[GuiMartialArts] 50043 0.5
//[GuiMartialArts] 50044 0.5
//[GuiMartialArts] 50045 0.5
//[GuiMartialArts] 50046 0.5
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 47
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20303 0 0 0
//[GuiMartialArts] 0 ٲȸľ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 3|4
//[GuiMartialArts] 70 Զ
//[GuiMartialArts] 71 Ƶ
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 221
//[GuiMartialArts] 104 5221
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.15|63&0.4|65&0.55|66&0.35|509&1.35
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0.5
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0.1
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 47
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20304 0 0 0
//[GuiMartialArts] 0 Ѩ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 3|4
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 222
//[GuiMartialArts] 104 5222
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.5|63&0.45|65&0.6|66&0.4|509&1.8
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0.1
//[GuiMartialArts] 50094 0.1
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20305 0 0 0
//[GuiMartialArts] 0 ת
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 223
//[GuiMartialArts] 104 5223
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.9|64&0.45|65&0.7|66&0.45|509&2.3
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 60
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0.5
//[GuiMartialArts] 49 0.5
//[GuiMartialArts] 50 0.5
//[GuiMartialArts] 51 4
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 450
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0.5
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 47
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20306 100 0 0
//[GuiMartialArts] 0 ʮŲ
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 쾮Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 224
//[GuiMartialArts] 104 5224
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.3|64&0.5|65&0.75|66&0.5|509&2.75
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 80
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 80
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 1.8
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0.6
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 600
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0.75
//[GuiMartialArts] 51101 0.1
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 1
//[GuiMartialArts] 50073 1
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20307 100 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 ׵Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 225
//[GuiMartialArts] 104 5225
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 3
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.65|64&0.55|65&0.8|66&0.55|509&3.2
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 1
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0.2
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 47
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20401 0 0 0
//[GuiMartialArts] 0 䵱
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 0|1
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 羮Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 228
//[GuiMartialArts] 104 5228
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.55|62&0.25|64&0.4|66&0.35|513&0.55
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 80
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 3
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0.3
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 200
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0.25
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.25
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 62
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20402 0 0 0
//[GuiMartialArts] 0 Ž
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 0|1|2|3|4|5|6
//[GuiMartialArts] 70 ɢۻ
//[GuiMartialArts] 71 ˮ
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 229
//[GuiMartialArts] 104 5229
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.8|63&0.6|66&0.55|513&0.8
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.25
//[GuiMartialArts] 50072 0.25
//[GuiMartialArts] 50073 0.25
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20403 0 0 0
//[GuiMartialArts] 0 ƴ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 0|1|2|3|4|5|6
//[GuiMartialArts] 70 ɽѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 230
//[GuiMartialArts] 104 5230
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.25|64&0.7|66&0.6|513&1.25
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 100
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 5
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0.5
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0.1
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20404 0 0 0
//[GuiMartialArts] 0 취
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 йѨ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 231
//[GuiMartialArts] 104 5231
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.65|64&0.8|66&0.65|513&1.65
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0.5
//[GuiMartialArts] 51110 0.5
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.1
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.75
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 62
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20405 0 0 0
//[GuiMartialArts] 0 Ԫ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ͨѨ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 232
//[GuiMartialArts] 104 5232
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.1|64&0.9|66&0.7|513&2.1
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 80
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 100
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 8
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0.8
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 1.5
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0.75
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.75
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20406 0 0 0
//[GuiMartialArts] 0 䵴ħ
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 0|1|2|3|4|5|6
//[GuiMartialArts] 70 Σ
//[GuiMartialArts] 71 ľ
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 233
//[GuiMartialArts] 104 5233
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.5|63&0.5|64&0.5|66&0.75|513&2.5
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.75
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 62
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20407 0 0 0
//[GuiMartialArts] 0 ޼
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 0|1|2|3|4|5|6
//[GuiMartialArts] 70 ˸
//[GuiMartialArts] 71 ǧ
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 234
//[GuiMartialArts] 104 5234
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.95|63&0.55|64&0.55|66&0.8|513&2.95
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 140
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 5
//[GuiMartialArts] 46 5
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 1
//[GuiMartialArts] 49 1
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 6
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 450
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 1.25
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0.2
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1.25
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20408 0 0 0
//[GuiMartialArts] 0 ۶
//[GuiMartialArts] 2 8
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 90
//[GuiMartialArts] 64 0.8
//[GuiMartialArts] 66 66
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 2
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ٻѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 545
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 235
//[GuiMartialArts] 104 5235
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 4
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 8
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&3.35|64&1.2|66&0.85|513&3.35
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0.75
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.2
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 -0.05
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 1.75
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20501 0 0 0
//[GuiMartialArts] 0 Źʮ˵
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 0|1|2|3|4|5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 236
//[GuiMartialArts] 104 5236
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 5
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.6|62&0.35|63&0.25|66&0.4|513&0.45|514&0.45
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 100
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 5
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 200
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.25
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 77
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20502 0 0 0
//[GuiMartialArts] 0 ൶ལ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 3|4
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 237
//[GuiMartialArts] 104 5237
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 5
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.9|61&0.35|63&0.3|66&0.5|513&0.65|514&0.65
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0.1
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20503 100 0 2
//[GuiMartialArts] 0 Ԫɽɷ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 0|1|2|3|4|5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 ֱݺ
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 238
//[GuiMartialArts] 104 5238
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 5
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.35|61&0.4|62&0.3|66&0.6|513&1|514&1
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.1
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.2
//[GuiMartialArts] 50082 0.2
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 77
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20504 0 0 0
//[GuiMartialArts] 0 𵶻ƹ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 0|1|3|4|5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 մƼ
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 239
//[GuiMartialArts] 104 5239
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 5
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.8|62&0.45|63&0.35|66&0.65|513&1.35|514&1.35
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 80
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 160
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 5
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 5
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 4
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 400
//[GuiMartialArts] 55 450
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.75
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.25
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.25
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 77
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20505 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 3|4
//[GuiMartialArts] 70 k
//[GuiMartialArts] 71 ۹
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 240
//[GuiMartialArts] 104 5240
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 5
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.3|61&0.9|66&0.7|513&1.7|514&1.7
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 1
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0.1
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 77
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20601 100 0 0
//[GuiMartialArts] 0 ʨͷ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 2
//[GuiMartialArts] 70 ͷ
//[GuiMartialArts] 71 ۶
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 243
//[GuiMartialArts] 104 5243
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 6
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.65|61&0.25|62&0.75
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 100
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0.3
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 2
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0.2
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0.2
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 200
//[GuiMartialArts] 55 350
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0.5
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20602 0 0 0
//[GuiMartialArts] 0 ׾
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 3|4|5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 縰
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 244
//[GuiMartialArts] 104 5244
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 6
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1|62&0.5|63&0.65
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 1
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20603 0 0 0
//[GuiMartialArts] 0 ǹ뷨
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 0|1
//[GuiMartialArts] 70 β
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 245
//[GuiMartialArts] 104 5245
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 6
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.5|62&1.3
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 80
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 180
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 8
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0.8
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 200
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0.75
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.1
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0.1
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.25
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20604 0 0 0
//[GuiMartialArts] 0 ٶ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 246
//[GuiMartialArts] 104 5246
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 6
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2|61&0.9|62&0.55
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 1
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20605 100 0 1
//[GuiMartialArts] 0 ʨХ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 2
//[GuiMartialArts] 70 ȱ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 247
//[GuiMartialArts] 104 5247
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 6
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.5|61&1|62&0.6
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0.5
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.75
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.75
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0.1
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20606 0 0 0
//[GuiMartialArts] 0 ׹
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 0|1
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 248
//[GuiMartialArts] 104 5248
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 6
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&3|61&0.35|62&1.4
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 100
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 140
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 1.8
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0.6
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 450
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0.2
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.75
//[GuiMartialArts] 50086 0.75
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.75
//[GuiMartialArts] 50073 0.75
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20701 0 0 0
//[GuiMartialArts] 0 ˷
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 3|4|5|6
//[GuiMartialArts] 70 ɽ
//[GuiMartialArts] 71 ˮ
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 249
//[GuiMartialArts] 104 5249
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.5|63&0.3|65&0.7|505&0.55|516&0.55
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 60
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 3
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0.3
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0.1
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20702 0 0 0
//[GuiMartialArts] 0 Ŀɶ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 2
//[GuiMartialArts] 70 ¹Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 250
//[GuiMartialArts] 104 5250
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.75|63&0.4|65&0.75|505&0.8|516&0.8
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20703 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 2
//[GuiMartialArts] 70 нѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 251
//[GuiMartialArts] 104 5251
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.15|64&0.4|65&0.9|505&1.25|516&1.25
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0.1
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20704 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 л
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 252
//[GuiMartialArts] 104 5252
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.5|65&1|66&0.45|505&1.65|516&1.65
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 100
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0.6
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 5
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0.5
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0.2
//[GuiMartialArts] 54 200
//[GuiMartialArts] 55 600
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.1
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0.1
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 1
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20705 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 0|1|2|3|4|5|6
//[GuiMartialArts] 70 Σ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 253
//[GuiMartialArts] 104 5253
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.9|64&0.5|65&1.1|505&2.1|516&2.1
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 1
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20706 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 254
//[GuiMartialArts] 104 5254
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.3|62&0.55|65&1.2|505&2.5|516&2.5
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 80
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 90
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0.6
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 5
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0.5
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0.2
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 450
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 2
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.4
//[GuiMartialArts] 50082 0.4
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20707 0 0 0
//[GuiMartialArts] 0 ת
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 255
//[GuiMartialArts] 104 5255
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 7
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.65|65&1.4|66&0.5|505&2.95|516&2.95
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 100
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 160
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 1.8
//[GuiMartialArts] 615 1.8
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0.5
//[GuiMartialArts] 53 0.5
//[GuiMartialArts] 54 400
//[GuiMartialArts] 55 450
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.75
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.3
//[GuiMartialArts] 50082 0.3
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20801 100 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 ȪѨ
//[GuiMartialArts] 71 ۧѨ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 257
//[GuiMartialArts] 104 5257
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.65|64&0.7|66&0.3
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 47
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20802 100 0 4
//[GuiMartialArts] 0 ʽ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 3|4|5|6
//[GuiMartialArts] 70 ˳
//[GuiMartialArts] 71 渴
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 258
//[GuiMartialArts] 104 5258
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1|63&0.75|65&0.4
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 60
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 5
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 200
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.25
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0.1
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 47
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20803 100 0 0
//[GuiMartialArts] 0 ī
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 0|1
//[GuiMartialArts] 70 ϹѨ
//[GuiMartialArts] 71 ʯѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 259
//[GuiMartialArts] 104 5259
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.5|64&0.8|65&0.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0.5
//[GuiMartialArts] 50042 0.5
//[GuiMartialArts] 50043 0.5
//[GuiMartialArts] 50044 0.5
//[GuiMartialArts] 50045 0.5
//[GuiMartialArts] 50046 0.5
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0.5
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 47
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20804 31 0 0
//[GuiMartialArts] 0 Ůɢ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 0|1|2|3|4|5|6
//[GuiMartialArts] 70 ȴ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 260
//[GuiMartialArts] 104 5260
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2|63&0.9|64&0.55
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.2
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 47
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20805 0 0 0
//[GuiMartialArts] 0 ϼ·
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 261
//[GuiMartialArts] 104 5261
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.5|64&0.9|65&0.7
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0.5
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 1
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0.1
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 47
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20806 0 0 0
//[GuiMartialArts] 0 ˮ
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 3|4|5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 Ǽ
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 262
//[GuiMartialArts] 104 5262
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&3|63&0.75|64&1
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 70
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 5
//[GuiMartialArts] 47 5
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 4
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 600
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 2
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.75
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.75
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 47
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20807 0 0 0
//[GuiMartialArts] 0 Ů洲ʽ
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ͥѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 263
//[GuiMartialArts] 104 5263
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 8
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&3.5|64&1.1|65&0.8
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 80
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 120
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 15
//[GuiMartialArts] 42 15
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 2
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 1
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.4
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 47
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20901 0 0 0
//[GuiMartialArts] 0 ְ˽Ź
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 3|4|5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 264
//[GuiMartialArts] 104 5264
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 9
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.5|62&0.35|63&0.35|65&0.3|507&0.6
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0.1
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.25
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.25
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20902 0 0 0
//[GuiMartialArts] 0 ľ׻
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 0|1
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 265
//[GuiMartialArts] 104 5265
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 9
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.75|62&0.8|65&0.35|507&0.9
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 80
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 90
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 3
//[GuiMartialArts] 42 3
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 400
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.1
//[GuiMartialArts] 50082 0.1
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.25
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.25
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 62
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20903 100 0 0
//[GuiMartialArts] 0 ټʮľ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 2
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 266
//[GuiMartialArts] 104 5266
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 9
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.15|62&0.45|63&0.45|65&0.4|507&1.35
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 -0.05
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.1
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0.2
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.75
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20904 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 0|1|2|3|4|5|6
//[GuiMartialArts] 70 Ի
//[GuiMartialArts] 71 ƾ
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 267
//[GuiMartialArts] 104 5267
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 9
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.5|62&0.5|63&0.5|65&0.45|507&1.8
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 62
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20905 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 0|1
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 268
//[GuiMartialArts] 104 5268
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 9
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.9|62&1.1|65&0.5|507&2.3
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 80
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 140
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0.8
//[GuiMartialArts] 44 0.8
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 200
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.75
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.2
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0.1
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.75
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 62
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ20906 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 0|1
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 ͨ
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 269
//[GuiMartialArts] 104 5269
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 9
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.3|62&1.2|65&0.55|507&2.75
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 80
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 5
//[GuiMartialArts] 46 5
//[GuiMartialArts] 47 5
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.2
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0.1
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 1
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 1
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21001 0 0 0
//[GuiMartialArts] 0 ָ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 3|4
//[GuiMartialArts] 70 ķ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 271
//[GuiMartialArts] 104 5271
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 10
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.45|63&0.3|65&0.4|66&0.3|509&0.6|510&0.6
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0.25
//[GuiMartialArts] 51110 0.25
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 77
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21002 0 0 0
//[GuiMartialArts] 0 ź
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 3|4
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 272
//[GuiMartialArts] 104 5272
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 10
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.65|63&0.35|65&0.45|66&0.35|509&0.9|510&0.9
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0.25
//[GuiMartialArts] 50033 0.25
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.25
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21003 100 0 0
//[GuiMartialArts] 0 ͸ʷ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 3|4
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 ѭ
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 273
//[GuiMartialArts] 104 5273
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 10
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1|63&0.4|65&0.5|66&0.4|509&1.35|510&1.35
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0.5
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.1
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.25
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21004 0 0 0
//[GuiMartialArts] 0 Ʊٶ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 274
//[GuiMartialArts] 104 5274
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 10
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.35|62&0.4|64&0.4|65&0.65|509&1.8|510&1.8
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 80
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 3
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0.3
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0.5
//[GuiMartialArts] 50042 0.5
//[GuiMartialArts] 50043 0.5
//[GuiMartialArts] 50044 0.5
//[GuiMartialArts] 50045 0.5
//[GuiMartialArts] 50046 0.5
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0.5
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.25
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 77
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21005 0 0 0
//[GuiMartialArts] 0 簲Ϣ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 ԫѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 275
//[GuiMartialArts] 104 5275
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 10
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.7|62&0.45|64&0.45|65&0.7|509&2.3|510&2.3
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0.5
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.1
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.1
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 1
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 77
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21006 0 0 0
//[GuiMartialArts] 0 Ѫ
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 0|1
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 276
//[GuiMartialArts] 104 5276
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 10
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.05|62&0.5|64&0.5|65&0.75|509&2.75|510&2.75
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0.5
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0.5
//[GuiMartialArts] 51110 0.75
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21007 0 0 0
//[GuiMartialArts] 0 ˮ
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 2
//[GuiMartialArts] 70 춦Ѩ
//[GuiMartialArts] 71 ӭѨ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 277
//[GuiMartialArts] 104 5277
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 10
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.4|62&0.55|64&0.55|65&0.8|509&3.2|510&3.2
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 1.5
//[GuiMartialArts] 50033 1.5
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 1
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 77
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21101 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 ֪
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 280
//[GuiMartialArts] 104 5280
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.6|62&0.35|64&0.35|66&0.3|514&0.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21102 100 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 3|4
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 281
//[GuiMartialArts] 104 5281
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.9|61&0.4|64&0.4|66&0.35|514&0.75
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 80
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 120
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0.2
//[GuiMartialArts] 49 0.2
//[GuiMartialArts] 50 0.2
//[GuiMartialArts] 51 2
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 400
//[GuiMartialArts] 55 350
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.1
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.25
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.25
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21103 100 0 0
//[GuiMartialArts] 0 ׽ǹ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 0|1|3|4|5|6
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 282
//[GuiMartialArts] 104 5282
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.35|62&0.9|66&0.4|514&1.15
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 20
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 140
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 3
//[GuiMartialArts] 46 3
//[GuiMartialArts] 47 3
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 200
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 1
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21104 0 0 0
//[GuiMartialArts] 0 ָӦ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 283
//[GuiMartialArts] 104 5283
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.8|62&0.5|64&0.5|66&0.45|514&1.5
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 1
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.75
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21105 0 0 0
//[GuiMartialArts] 0 ݱ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 284
//[GuiMartialArts] 104 5284
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.3|64&0.8|66&0.8|514&1.9
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 80
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 140
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 8
//[GuiMartialArts] 42 8
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 400
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.2
//[GuiMartialArts] 50082 0.2
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21106 0 0 0
//[GuiMartialArts] 0 ׾
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 285
//[GuiMartialArts] 104 5285
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.75|62&0.7|64&0.4|66&0.65|514&2.3
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 60
//[GuiMartialArts] 9 100
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 160
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 1.2
//[GuiMartialArts] 615 1.2
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0.5
//[GuiMartialArts] 44 0.5
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0.4
//[GuiMartialArts] 53 0.4
//[GuiMartialArts] 54 400
//[GuiMartialArts] 55 600
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 2
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 1.5
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21107 0 0 0
//[GuiMartialArts] 0 ӡ
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 ʵס
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 286
//[GuiMartialArts] 104 5286
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&3.2|62&0.75|64&0.45|66&0.7|514&2.65
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0.75
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 1.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21108 100 0 0
//[GuiMartialArts] 0 ɷ
//[GuiMartialArts] 2 8
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 90
//[GuiMartialArts] 64 0.8
//[GuiMartialArts] 66 66
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 545
//[GuiMartialArts] 99 ߷ģ߶϶ƣҷߵôܣ֪߼ɷ𡱡Ψжٳɮ٣ΪʳĴ֮ʿ޵üɷ֮
//[GuiMartialArts] 103 287
//[GuiMartialArts] 104 5287
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 11
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 1
//[GuiMartialArts] 5 8
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&3.65|62&1.3|66&0.75|514&3.05
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 100
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 200
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 10
//[GuiMartialArts] 42 10
//[GuiMartialArts] 43 1
//[GuiMartialArts] 44 1
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 1.75
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.3
//[GuiMartialArts] 50082 0.3
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 17
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21201 0 0 0
//[GuiMartialArts] 0 Գ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 ȱѨ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 288
//[GuiMartialArts] 104 5288
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.45|63&0.5|65&0.5|510&0.65
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21202 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 ӭѨ
//[GuiMartialArts] 71 زѨ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 289
//[GuiMartialArts] 104 5289
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.65|64&0.6|65&0.55|510&1
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 70
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0.3
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 2
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0.2
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0.2
//[GuiMartialArts] 54 200
//[GuiMartialArts] 55 350
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.1
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21203 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 СѨ
//[GuiMartialArts] 71 ϪѨ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 290
//[GuiMartialArts] 104 5290
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1|62&0.7|65&0.6|510&1.5
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0.1
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.1
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.25
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21204 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 291
//[GuiMartialArts] 104 5291
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.35|63&0.4|64&0.4|65&0.65|510&2
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 80
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 120
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 5
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 1
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 200
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0.25
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0.1
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21205 0 0 0
//[GuiMartialArts] 0 Ѫżɷ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ͹Ѩ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 292
//[GuiMartialArts] 104 5292
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.7|62&0.9|65&0.7|510&2.5
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 50
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 90
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 5
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 1
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0.1
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21206 0 0 0
//[GuiMartialArts] 0 ɥϢ
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 293
//[GuiMartialArts] 104 5293
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.05|62&0.45|63&0.5|65&0.8|510&3
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 60
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 5
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 1
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 400
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 -0.05
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0.1
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21207 0 0 0
//[GuiMartialArts] 0 ɹ
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 βѨ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 294
//[GuiMartialArts] 104 5294
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.4|64&1|65&0.9|510&3.5
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 1
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21208 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 8
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 90
//[GuiMartialArts] 64 0.8
//[GuiMartialArts] 66 66
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 545
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 295
//[GuiMartialArts] 104 5295
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 8
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.75|62&0.5|63&0.55|65&1|510&4
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 100
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 90
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 5
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 5
//[GuiMartialArts] 48 1
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 1
//[GuiMartialArts] 51 6
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 550
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0.75
//[GuiMartialArts] 50086 0.75
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21209 100 0 0
//[GuiMartialArts] 0 ߻ǹ
//[GuiMartialArts] 2 9
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 5
//[GuiMartialArts] 63 100
//[GuiMartialArts] 64 0.9
//[GuiMartialArts] 66 83
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 8
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 Ѫ
//[GuiMartialArts] 73 680
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 296
//[GuiMartialArts] 104 5296
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 12
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 2
//[GuiMartialArts] 5 9
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&3.1|62&0.6|64&0.5|65&1.1|510&4.5
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 1
//[GuiMartialArts] 50072 1
//[GuiMartialArts] 50073 1
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 32
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21301 25 0 0
//[GuiMartialArts] 0 ͨ
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 2
//[GuiMartialArts] 70 ̨Ѩ
//[GuiMartialArts] 71 ٻѨ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 297
//[GuiMartialArts] 104 5297
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 13
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.55|63&0.25|64&0.25|65&0.5|505&0.55
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.2
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0.25
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 47
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21302 100 0 0
//[GuiMartialArts] 0 ӲȢ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 0|1
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 298
//[GuiMartialArts] 104 5298
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 13
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 3
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.8|63&0.3|64&0.3|65&0.55|505&0.8
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 80
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 3
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 3
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 3
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 400
//[GuiMartialArts] 55 350
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.25
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.25
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 47
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21303 0 0 0
//[GuiMartialArts] 0 ת
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 9
//[GuiMartialArts] 70 ϹѨ
//[GuiMartialArts] 71 춦Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 299
//[GuiMartialArts] 104 5299
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 13
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.25|64&0.65|65&0.65|505&1.25
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 100
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 60
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 5
//[GuiMartialArts] 46 5
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 4
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 350
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 1
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0.1
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 1
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21401 21 0 0
//[GuiMartialArts] 0 ŭ๦
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 2
//[GuiMartialArts] 70 ճ
//[GuiMartialArts] 71 ӡ
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 303
//[GuiMartialArts] 104 5303
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.65|61&0.7|62&0.3
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.2
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.25
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 62
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21402 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 1
//[GuiMartialArts] 70 ľ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ֹλ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 304
//[GuiMartialArts] 104 5304
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1|61&0.75|63&0.4
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 120
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 3
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0.3
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 200
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.25
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0.1
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 62
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21403 0 0 0
//[GuiMartialArts] 0 ֹ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 0|1
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ̫Ѩ
//[GuiMartialArts] 72 ʮ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 305
//[GuiMartialArts] 104 5305
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.5|61&0.45|62&0.5|64&0.35
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 30
//[GuiMartialArts] 9 100
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 200
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0.6
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 5
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0.5
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0.2
//[GuiMartialArts] 54 100
//[GuiMartialArts] 55 450
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0.25
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0.2
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 62
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21404 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 0|1|2|3|4|5|6
//[GuiMartialArts] 70 ֱ
//[GuiMartialArts] 71 β
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 306
//[GuiMartialArts] 104 5306
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2|61&0.85|62&0.6
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0.5
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 62
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21405 76 0 0
//[GuiMartialArts] 0 ׹
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 0|1
//[GuiMartialArts] 70 ޹
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 307
//[GuiMartialArts] 104 5307
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.5|61&0.9|62&0.7
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 100
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 160
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0.6
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 5
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0.5
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0.2
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 400
//[GuiMartialArts] 55 450
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 2
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 1
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.5
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 62
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21406 0 0 0
//[GuiMartialArts] 0 â
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 0|1
//[GuiMartialArts] 70 Ѩ
//[GuiMartialArts] 71 ׵Ѩ
//[GuiMartialArts] 72 澭
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 308
//[GuiMartialArts] 104 5308
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 4
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&3|61&0.95|64&0.8
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 1
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 1
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 62
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21407 0 0 0
//[GuiMartialArts] 0 ǧ
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 309
//[GuiMartialArts] 104 5309
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 14
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&3.5|61&1|62&0.9
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.2
//[GuiMartialArts] 51102 0.2
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.5
//[GuiMartialArts] 50072 0.5
//[GuiMartialArts] 50073 0.5
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21501 37 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 1
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 20
//[GuiMartialArts] 64 0.1
//[GuiMartialArts] 66 3
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 5
//[GuiMartialArts] 69 0|1|2|3|4|5|6
//[GuiMartialArts] 70 Ծ
//[GuiMartialArts] 71 ô
//[GuiMartialArts] 72 ɷ
//[GuiMartialArts] 73 20
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 311
//[GuiMartialArts] 104 5311
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 1
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&0.65|63&0.65|65&0.35
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 80
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 5
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 200
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.25
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 77
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21502 0 0 0
//[GuiMartialArts] 0 ɱ
//[GuiMartialArts] 2 2
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 1
//[GuiMartialArts] 63 30
//[GuiMartialArts] 64 0.2
//[GuiMartialArts] 66 6
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 ѹ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 50
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 312
//[GuiMartialArts] 104 5312
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 2
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1|61&0.75|62&0.4
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 77
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21503 0 0 0
//[GuiMartialArts] 0 ҹ
//[GuiMartialArts] 2 3
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 40
//[GuiMartialArts] 64 0.3
//[GuiMartialArts] 66 11
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 4
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 Թ
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 95
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 313
//[GuiMartialArts] 104 5313
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 1
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 3
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&1.5|61&0.45|63&0.45|65&0.4
//[GuiMartialArts] 711 3
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 40
//[GuiMartialArts] 9 60
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 90
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 3
//[GuiMartialArts] 46 3
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 3
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 450
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.25
//[GuiMartialArts] 50085 0.25
//[GuiMartialArts] 50086 0.25
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 77
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21504 0 0 0
//[GuiMartialArts] 0 Ѫʳ
//[GuiMartialArts] 2 4
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 2
//[GuiMartialArts] 63 50
//[GuiMartialArts] 64 0.4
//[GuiMartialArts] 66 18
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 3
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 ̰ɱ
//[GuiMartialArts] 71 Ѫ
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 155
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 314
//[GuiMartialArts] 104 5314
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 4
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2|61&0.8|62&0.3|65&0.35
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0.5
//[GuiMartialArts] 50042 0.5
//[GuiMartialArts] 50043 0.5
//[GuiMartialArts] 50044 0.5
//[GuiMartialArts] 50045 0.5
//[GuiMartialArts] 50046 0.5
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0.75
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0.1
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 77
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21505 0 0 0
//[GuiMartialArts] 0 ƻ
//[GuiMartialArts] 2 5
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 60
//[GuiMartialArts] 64 0.5
//[GuiMartialArts] 66 27
//[GuiMartialArts] 67 1
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 ػ
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 230
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 315
//[GuiMartialArts] 104 5315
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 0
//[GuiMartialArts] 5 5
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&2.5|63&0.8|65&0.8
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 70
//[GuiMartialArts] 9 80
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 140
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0.6
//[GuiMartialArts] 615 0.6
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0.3
//[GuiMartialArts] 53 0.3
//[GuiMartialArts] 54 300
//[GuiMartialArts] 55 600
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0.75
//[GuiMartialArts] 50022 0.25
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 2
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21506 0 0 0
//[GuiMartialArts] 0 
//[GuiMartialArts] 2 6
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 3
//[GuiMartialArts] 63 70
//[GuiMartialArts] 64 0.6
//[GuiMartialArts] 66 38
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 2
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 Ψ
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 320
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 316
//[GuiMartialArts] 104 5316
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 2
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 0
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 6
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&3|61&0.9|65&0.85
//[GuiMartialArts] 711 6
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0.75
//[GuiMartialArts] 50072 0.75
//[GuiMartialArts] 50073 0.75
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 77
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21507 0 0 0
//[GuiMartialArts] 0 ʮѪͯ
//[GuiMartialArts] 2 7
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 80
//[GuiMartialArts] 64 0.7
//[GuiMartialArts] 66 51
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 425
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 317
//[GuiMartialArts] 104 5317
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 7
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&3.5|61&1|62&0.45|64&0.45
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0.75
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0.5
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0.75
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0.1
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0.5
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 77
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21508 0 0 0
//[GuiMartialArts] 0 ħͨ
//[GuiMartialArts] 2 8
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 4
//[GuiMartialArts] 63 90
//[GuiMartialArts] 64 0.8
//[GuiMartialArts] 66 66
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 ܷ
//[GuiMartialArts] 71 ʶ
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 545
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 318
//[GuiMartialArts] 104 5318
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 3
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 8
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&4|61&1.3|65&0.75
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 C_006
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 80
//[GuiMartialArts] 9 100
//[GuiMartialArts] 31 999
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 180
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 1.5
//[GuiMartialArts] 44 1.5
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 200
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 0
//[GuiMartialArts] 50033 0
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0.5
//[GuiMartialArts] 51110 0.5
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0.3
//[GuiMartialArts] 50082 0.3
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0
//[GuiMartialArts] 50085 1
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 77
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ21509 100 0 0
//[GuiMartialArts] 0 Ѫͯ
//[GuiMartialArts] 2 9
//[GuiMartialArts] 61 103
//[GuiMartialArts] 62 5
//[GuiMartialArts] 63 100
//[GuiMartialArts] 64 0.9
//[GuiMartialArts] 66 83
//[GuiMartialArts] 67 0
//[GuiMartialArts] 68 1
//[GuiMartialArts] 69 7
//[GuiMartialArts] 70 ޻
//[GuiMartialArts] 71 
//[GuiMartialArts] 72 ʶ
//[GuiMartialArts] 73 680
//[GuiMartialArts] 99 ˵
//[GuiMartialArts] 103 319
//[GuiMartialArts] 104 5319
//[GuiMartialArts] 1 2
//[GuiMartialArts] 6 4
//[GuiMartialArts] 7 3
//[GuiMartialArts] 3 15
//[GuiMartialArts] 15 1
//[GuiMartialArts] 16 1
//[GuiMartialArts] 4 5
//[GuiMartialArts] 5 9
//[GuiMartialArts] 701 0
//[GuiMartialArts] 702 0
//[GuiMartialArts] 703 0
//[GuiMartialArts] 704 0
//[GuiMartialArts] 705 0
//[GuiMartialArts] 999 120
//[GuiMartialArts] 710 603&4.5|61&0.25|62&1|64&0.95
//[GuiMartialArts] 711 9
//[GuiMartialArts] 901 0
//[GuiMartialArts] 902 0
//[GuiMartialArts] 903 0
//[GuiMartialArts] 904 0
//[GuiMartialArts] 905 0
//[GuiMartialArts] 906 0
//[GuiMartialArts] 907 0
//[GuiMartialArts] 908 0
//[GuiMartialArts] 909 0
//[GuiMartialArts] 910 0
//[GuiMartialArts] 921 0
//[GuiMartialArts] 922 0
//[GuiMartialArts] 923 0
//[GuiMartialArts] 924 0
//[GuiMartialArts] 95 0
//[GuiMartialArts] 96 0
//[GuiMartialArts] 501 0
//[GuiMartialArts] 502 0
//[GuiMartialArts] 503 0
//[GuiMartialArts] 504 0
//[GuiMartialArts] 14 0
//[GuiMartialArts] 8 0
//[GuiMartialArts] 9 0
//[GuiMartialArts] 31 0
//[GuiMartialArts] 38 0
//[GuiMartialArts] 39 0
//[GuiMartialArts] 40 0
//[GuiMartialArts] 10 0
//[GuiMartialArts] 11 0|0
//[GuiMartialArts] 12 0|0
//[GuiMartialArts] 13 0|0
//[GuiMartialArts] 101 0
//[GuiMartialArts] 21 0
//[GuiMartialArts] 22 0
//[GuiMartialArts] 23 0
//[GuiMartialArts] 24 0
//[GuiMartialArts] 25 0
//[GuiMartialArts] 26 0
//[GuiMartialArts] 27 0
//[GuiMartialArts] 28 0
//[GuiMartialArts] 29 0
//[GuiMartialArts] 30 0
//[GuiMartialArts] 601 0
//[GuiMartialArts] 602 0
//[GuiMartialArts] 603 0
//[GuiMartialArts] 611 0
//[GuiMartialArts] 612 0
//[GuiMartialArts] 613 0
//[GuiMartialArts] 614 0
//[GuiMartialArts] 615 0
//[GuiMartialArts] 604 0
//[GuiMartialArts] 41 0
//[GuiMartialArts] 42 0
//[GuiMartialArts] 43 0
//[GuiMartialArts] 44 0
//[GuiMartialArts] 45 0
//[GuiMartialArts] 46 0
//[GuiMartialArts] 47 0
//[GuiMartialArts] 48 0
//[GuiMartialArts] 49 0
//[GuiMartialArts] 50 0
//[GuiMartialArts] 51 0
//[GuiMartialArts] 52 0
//[GuiMartialArts] 53 0
//[GuiMartialArts] 54 0
//[GuiMartialArts] 55 0
//[GuiMartialArts] 32 0
//[GuiMartialArts] 33 0
//[GuiMartialArts] 34 0
//[GuiMartialArts] 35 0
//[GuiMartialArts] 36 0
//[GuiMartialArts] 81 0
//[GuiMartialArts] 82 0
//[GuiMartialArts] 83 0
//[GuiMartialArts] 84 0
//[GuiMartialArts] 85 0
//[GuiMartialArts] 86 0
//[GuiMartialArts] 50041 0
//[GuiMartialArts] 50042 0
//[GuiMartialArts] 50043 0
//[GuiMartialArts] 50044 0
//[GuiMartialArts] 50045 0
//[GuiMartialArts] 50046 0
//[GuiMartialArts] 50032 1.5
//[GuiMartialArts] 50033 1.5
//[GuiMartialArts] 50022 0
//[GuiMartialArts] 50023 0
//[GuiMartialArts] 51110 0
//[GuiMartialArts] 51101 0
//[GuiMartialArts] 51102 0
//[GuiMartialArts] 51103 0
//[GuiMartialArts] 51104 0
//[GuiMartialArts] 51105 0
//[GuiMartialArts] 51106 0
//[GuiMartialArts] 51107 0
//[GuiMartialArts] 51108 0
//[GuiMartialArts] 51109 0
//[GuiMartialArts] 51111 0
//[GuiMartialArts] 50081 0
//[GuiMartialArts] 50082 0
//[GuiMartialArts] 50083 0
//[GuiMartialArts] 51367 0
//[GuiMartialArts] 51368 0
//[GuiMartialArts] 51369 0
//[GuiMartialArts] 50084 0.75
//[GuiMartialArts] 50085 0
//[GuiMartialArts] 50086 0
//[GuiMartialArts] 51370 0
//[GuiMartialArts] 51371 0
//[GuiMartialArts] 51372 0
//[GuiMartialArts] 50071 0
//[GuiMartialArts] 50072 0
//[GuiMartialArts] 50073 0
//[GuiMartialArts] 50092 0
//[GuiMartialArts] 50093 0
//[GuiMartialArts] 50094 0
//[GuiMartialArts] 50095 0
//[GuiMartialArts] 50096 0
//[GuiMartialArts] 50097 0
//[GuiMartialArts] 50098 0
//[GuiMartialArts] 98 77
//[GuiMartialArts] 37 0
//[GuiMartialArts] 91 0
//[GuiMartialArts] ҹ30101 0 0 0
//[GuiMartialArts] 0 ֳȭ
//[GuiMartialArts] 2 1
#endregion